#line 1 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/ServerTest.c"
#line 1 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
#line 1 "c:/users/richard/google drive/projects/servertestbox/__netethenc28j60.h"
#line 105 "c:/users/richard/google drive/projects/servertestbox/__netethenc28j60.h"
typedef struct
 {
 unsigned char valid;
 unsigned long tmr;
 unsigned char ip[4];
 unsigned char mac[6];
 } Net_Ethernet_28j60_arpCacheStruct;

extern Net_Ethernet_28j60_arpCacheStruct Net_Ethernet_28j60_arpCache[];

extern unsigned char Net_Ethernet_28j60_macAddr[6];
extern unsigned char Net_Ethernet_28j60_ipAddr[4];
extern unsigned char Net_Ethernet_28j60_gwIpAddr[4];
extern unsigned char Net_Ethernet_28j60_ipMask[4];
extern unsigned char Net_Ethernet_28j60_dnsIpAddr[4];
extern unsigned char Net_Ethernet_28j60_rmtIpAddr[4];

extern unsigned long Net_Ethernet_28j60_userTimerSec;



typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;
 unsigned int dataLength;
 unsigned int broadcastMark;
} UDP_28j60_Dsc;


extern UDP_28j60_Dsc udpRecord_28j60;



typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;

 unsigned int dataLength;
 unsigned int remoteMSS;
 unsigned int myWin;
 unsigned int myMSS;
 unsigned long mySeq;
 unsigned long myACK;

 char stateTimer;
 char retransmitTimer;
 unsigned int packetID;
 char open;
 char ID;
 char broadcastMark;
 char state;









 unsigned int nextSend;
 unsigned int lastACK;
 unsigned int lastSent;
 unsigned int lastWritten;
 unsigned int numToSend;
 char buffState;
 char *txBuffer;


} SOCKET_28j60_Dsc;


extern const char NUM_OF_SOCKET_28j60;
extern const unsigned int TCP_TX_SIZE_28j60;
extern const unsigned int MY_MSS_28j60;
extern const unsigned int SYN_FIN_WAIT_28j60;
extern const unsigned int RETRANSMIT_WAIT_28j60;

extern char tx_buffers_28j60[][];
extern SOCKET_28j60_Dsc socket_28j60[];
#line 200 "c:/users/richard/google drive/projects/servertestbox/__netethenc28j60.h"
extern void Net_Ethernet_28j60_Init(unsigned char *resetPort, unsigned char resetBit, unsigned char *CSport, unsigned char CSbit, unsigned char *mac, unsigned char *ip, unsigned char configuration);
extern unsigned char Net_Ethernet_28j60_doPacket();
extern void Net_Ethernet_28j60_putByte(unsigned char b);
extern void Net_Ethernet_28j60_putBytes(unsigned char *ptr, unsigned int n);
extern void Net_Ethernet_28j60_putConstBytes(const unsigned char *ptr, unsigned int n);
extern unsigned char Net_Ethernet_28j60_getByte();
extern void Net_Ethernet_28j60_getBytes(unsigned char *ptr, unsigned int addr, unsigned int n);
extern unsigned int Net_Ethernet_28j60_UserUDP(UDP_28j60_Dsc *udpDsc);
extern void Net_Ethernet_28j60_payloadInitUDP();
extern void Net_Ethernet_28j60_UserTCP(SOCKET_28j60_Dsc *socket);
extern void Net_Ethernet_28j60_confNetwork(char *ipMask, char *gwIpAddr, char *dnsIpAddr);

extern char Net_Ethernet_28j60_connectTCP(char *remoteIP, unsigned int remote_port ,unsigned int my_port, SOCKET_28j60_Dsc **used_socket);
extern char Net_Ethernet_28j60_disconnectTCP(SOCKET_28j60_Dsc *socket);
extern char Net_Ethernet_28j60_startSendTCP(SOCKET_28j60_Dsc *socket);

extern char Net_Ethernet_28j60_putByteTCP(char ch, SOCKET_28j60_Dsc *socket);
extern unsigned int Net_Ethernet_28j60_putBytesTCP(char *ptr,unsigned int n, SOCKET_28j60_Dsc *socket);
extern unsigned int Net_Ethernet_28j60_putConstBytesTCP(const far char *ptr,unsigned int n, SOCKET_28j60_Dsc *socket);
extern unsigned int Net_Ethernet_28j60_putStringTCP(char *ptr, SOCKET_28j60_Dsc *socket);
extern unsigned int Net_Ethernet_28j60_putConstStringTCP(const far char *ptr, SOCKET_28j60_Dsc *socket);
extern char Net_Ethernet_28j60_bufferEmptyTCP(SOCKET_28j60_Dsc *socket);
extern void Net_Ethernet_28j60_stackInitTCP();
#line 62 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
enum {
 LOG_NORMAL = 0,
 LOG_ERROR,
 LOG_UNKNOWN
};
#line 71 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
enum {
 FILE_HTML = 0,
 FILE_CSS,
 FILE_JS,
 FILE_PNG,
 FILE_ICO,
 FILE_JPG,
 FILE_LOG
};
#line 84 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
enum {
 DHCP_OFF = 0,
 DHCP_ON
};
#line 92 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
struct ipAddress_desc{
 unsigned char ip1;
 unsigned char ip2;
 unsigned char ip3;
 unsigned char ip4;
};

typedef struct ipAddress_desc ipAddress_t;
#line 105 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
struct webServer_desc {
 const void(*Init)(void);
 const void(*FSInit)(void);
 const void(*DoPacket)(void);
 const void(*LogEvent)(int log, char* text);
 const void(*SetIP)(ipAddress_t *address);
 const void(*SetSubIP)(ipAddress_t *address);
 const void(*SetGW)(ipAddress_t *address);
 const void(*SetDNS)(ipAddress_t *address);
 const void(*SetDHCP)(int mode);
 const void(*SetPort)(unsigned short portNum);
 const void(*GetTime)(unsigned char *ntpSvr);
 const char*(*GetData)(unsigned char *request);
 const int(*GetFreeSockets)(void);
};
#line 128 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void webserverInit(void);
#line 133 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void SDCardInit(void);
#line 138 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void doPacket(void);
#line 145 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void logEvent(int log, char* text);
#line 150 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setIP(ipAddress_t *address);
#line 155 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setSubIP(ipAddress_t *address);
#line 160 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setGW(ipAddress_t *address);
#line 165 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setDNS(ipAddress_t *address);
#line 170 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setDHCP(int mode);
#line 175 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setPort(unsigned short portNum);
#line 182 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
extern void getSvrTime(unsigned char *ntpSrv);
#line 196 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
extern char* getSvrData(unsigned char *request);
#line 203 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
extern int getNumFreeSockets(void);
#line 208 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
extern struct webServer_desc Webserver;
#line 4 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/ServerTest.c"
void second_ISR() iv IVT_ADDR_TIMER1_COMPA ics ICS_AUTO {
 asm cli;
 Net_Ethernet_28j60_UserTimerSec++;

 TCNT1H = 0xE17C >> 8;
 TCNT1L = 0xE18C;
 asm sei;
}


void main() {
 TCCR1B |= (1 << CS12) | (1 << CS10);
 OCR1AH = 0x1E83 >> 8;
 OCR1AL = 0x1E83;
 TIMSK1 |= (1 << OCIE1A);
 UART1_Init(19200);
 asm sei;

 SPI1_Init_Advanced(_SPI_MASTER, _SPI_FCY_DIV128, _SPI_CLK_LO_LEADING);
 Webserver.FSInit();

 SPI1_Init_Advanced(_SPI_MASTER, _SPI_FCY_DIV2, _SPI_CLK_LO_LEADING);
 Webserver.Init();
 UART_Write_Text("Started\n");

 while(1){
 Webserver.DoPacket();

 }

}
