
_cardInsertISR:
	PUSH       R30
	PUSH       R31
	PUSH       R27
	IN         R27, SREG+0
	PUSH       R27

;webserver.c,148 :: 		void cardInsertISR() iv IVT_ADDR_PCINT2 ics ICS_AUTO {
;webserver.c,149 :: 		if(Button(&PINC, 5, 30, 0)) {
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	CLR        R6
	LDI        R27, 30
	MOV        R5, R27
	LDI        R27, 5
	MOV        R4, R27
	LDI        R27, #lo_addr(PINC+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PINC+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__cardInsertISR171
	JMP        L_cardInsertISR0
L__cardInsertISR171:
;webserver.c,150 :: 		sdCardInsert = 1;
	LDS        R27, _sdCardInsert+0
	SBR        R27, BitMask(_sdCardInsert+0)
	STS        _sdCardInsert+0, R27
;webserver.c,151 :: 		} else {
	JMP        L_cardInsertISR1
L_cardInsertISR0:
;webserver.c,152 :: 		sdCardInsert = 0;
	LDS        R27, _sdCardInsert+0
	CBR        R27, BitMask(_sdCardInsert+0)
	STS        _sdCardInsert+0, R27
;webserver.c,153 :: 		status = NOTREADY;
	LDS        R27, _status+0
	CBR        R27, BitMask(_status+0)
	STS        _status+0, R27
;webserver.c,154 :: 		}
L_cardInsertISR1:
;webserver.c,155 :: 		}
L_end_cardInsertISR:
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	POP        R27
	OUT        SREG+0, R27
	POP        R27
	POP        R31
	POP        R30
	RETI
; end of _cardInsertISR

webserver_validateFile:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;webserver.c,157 :: 		static int validateFile(int file_t, int index, char* name){
;webserver.c,158 :: 		FAT32_ChangeDir("\\");
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R7
	PUSH       R6
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr1_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr1_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
;webserver.c,159 :: 		FAT32_ChangeDir("WEB");
	LDI        R27, #lo_addr(?lstr2_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr2_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R6
	POP        R7
;webserver.c,160 :: 		switch (file_t){
	JMP        L_webserver_validateFile2
;webserver.c,161 :: 		case FILE_CSS:
L_webserver_validateFile4:
;webserver.c,162 :: 		FAT32_ChangeDir("STYLES");
	PUSH       R7
	PUSH       R6
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr3_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr3_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R6
	POP        R7
;webserver.c,163 :: 		break;
	JMP        L_webserver_validateFile3
;webserver.c,164 :: 		case FILE_JS:
L_webserver_validateFile5:
;webserver.c,165 :: 		FAT32_ChangeDir("SCRIPTS");
	PUSH       R7
	PUSH       R6
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr4_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr4_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R6
	POP        R7
;webserver.c,166 :: 		break;
	JMP        L_webserver_validateFile3
;webserver.c,167 :: 		case FILE_PNG:
L_webserver_validateFile6:
;webserver.c,168 :: 		FAT32_ChangeDir("IMAGES");
	PUSH       R7
	PUSH       R6
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr5_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr5_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R6
	POP        R7
;webserver.c,169 :: 		break;
	JMP        L_webserver_validateFile3
;webserver.c,170 :: 		case FILE_JPG:
L_webserver_validateFile7:
;webserver.c,171 :: 		FAT32_ChangeDir("IMAGES");
	PUSH       R7
	PUSH       R6
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr6_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr6_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R6
	POP        R7
;webserver.c,172 :: 		break;
	JMP        L_webserver_validateFile3
;webserver.c,173 :: 		}
L_webserver_validateFile2:
	LDI        R27, 0
	CP         R3, R27
	BRNE       L_webserver_validateFile173
	LDI        R27, 1
	CP         R2, R27
L_webserver_validateFile173:
	BRNE       L_webserver_validateFile174
	JMP        L_webserver_validateFile4
L_webserver_validateFile174:
	LDI        R27, 0
	CP         R3, R27
	BRNE       L_webserver_validateFile175
	LDI        R27, 2
	CP         R2, R27
L_webserver_validateFile175:
	BRNE       L_webserver_validateFile176
	JMP        L_webserver_validateFile5
L_webserver_validateFile176:
	LDI        R27, 0
	CP         R3, R27
	BRNE       L_webserver_validateFile177
	LDI        R27, 3
	CP         R2, R27
L_webserver_validateFile177:
	BRNE       L_webserver_validateFile178
	JMP        L_webserver_validateFile6
L_webserver_validateFile178:
	LDI        R27, 0
	CP         R3, R27
	BRNE       L_webserver_validateFile179
	LDI        R27, 5
	CP         R2, R27
L_webserver_validateFile179:
	BRNE       L_webserver_validateFile180
	JMP        L_webserver_validateFile7
L_webserver_validateFile180:
L_webserver_validateFile3:
;webserver.c,174 :: 		if(FAT32_Exists(name) == 1){
	PUSH       R7
	PUSH       R6
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOVW       R2, R6
	CALL       _FAT32_Exists+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	POP        R6
	POP        R7
	CPI        R16, 1
	BREQ       L_webserver_validateFile181
	JMP        L_webserver_validateFile8
L_webserver_validateFile181:
;webserver.c,175 :: 		webSoc[index].filetype = file_t;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 21
	ST         Z+, R2
	ST         Z+, R3
;webserver.c,176 :: 		webSoc[index].mark = 1;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, 1
	ST         Z, R27
;webserver.c,177 :: 		webSoc[index].position = 0;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 3
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
;webserver.c,178 :: 		strcpy(&webSoc[index].fileName, name);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 249
	SBCI       R17, 255
	PUSH       R5
	PUSH       R4
	MOVW       R4, R6
	MOVW       R2, R16
	CALL       _strcpy+0
	POP        R4
	POP        R5
;webserver.c,179 :: 		FAT32_Size(webSoc[index].fileName, &webSoc[index].fileSize);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R18, R16
	SUBI       R18, 233
	SBCI       R19, 255
	SUBI       R16, 249
	SBCI       R17, 255
	PUSH       R5
	PUSH       R4
	MOVW       R4, R18
	MOVW       R2, R16
	CALL       _FAT32_Size+0
	POP        R4
	POP        R5
;webserver.c,180 :: 		webSoc[index].fileHandle = FAT32_Open(&webSoc[index].fileName, FILE_READ);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R18, R16
	ADC        R19, R17
	MOVW       R16, R18
	SUBI       R16, 236
	SBCI       R17, 255
	STD        Y+0, R16
	STD        Y+1, R17
	MOVW       R16, R18
	SUBI       R16, 249
	SBCI       R17, 255
	PUSH       R5
	PUSH       R4
	LDI        R27, 1
	MOV        R4, R27
	MOVW       R2, R16
	CALL       _FAT32_Open+0
	POP        R4
	POP        R5
	LDD        R17, Y+0
	LDD        R18, Y+1
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;webserver.c,181 :: 		if(webSoc[index].fileHandle == -1) logEvent(LOG_ERROR, "Filehandle Failed");
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 20
	LD         R16, Z
	CPI        R16, 255
	BREQ       L_webserver_validateFile182
	JMP        L_webserver_validateFile9
L_webserver_validateFile182:
	PUSH       R5
	PUSH       R4
	LDI        R27, #lo_addr(?lstr7_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr7_webserver+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _logEvent+0
	POP        R4
	POP        R5
L_webserver_validateFile9:
;webserver.c,183 :: 		memset(&webSoc[index].buffer, 0, DATABUFFERSIZE);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 229
	SBCI       R17, 255
	PUSH       R5
	PUSH       R4
	LDI        R27, 0
	MOV        R5, R27
	LDI        R27, 2
	MOV        R6, R27
	CLR        R4
	MOVW       R2, R16
	CALL       _memset+0
	POP        R4
	POP        R5
;webserver.c,184 :: 		if(FAT32_Read(webSoc[index].fileHandle, &webSoc[index].buffer, DATABUFFERSIZE)==0){
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R18, R16
	SUBI       R18, 229
	SBCI       R19, 255
	MOVW       R30, R16
	ADIW       R30, 20
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	LDI        R27, 0
	MOV        R5, R27
	LDI        R27, 2
	MOV        R6, R27
	MOV        R3, R18
	MOV        R4, R19
	MOV        R2, R16
	CALL       _FAT32_Read+0
	POP        R4
	POP        R5
	CPI        R16, 0
	BREQ       L_webserver_validateFile183
	JMP        L_webserver_validateFile10
L_webserver_validateFile183:
;webserver.c,185 :: 		webSoc[index].bufPos = 0;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	SUBI       R30, 229
	SBCI       R31, 253
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
;webserver.c,186 :: 		} else {
	JMP        L_webserver_validateFile11
L_webserver_validateFile10:
;webserver.c,187 :: 		logEvent(LOG_ERROR, "Could not read from file");
	LDI        R27, #lo_addr(?lstr8_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr8_webserver+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _logEvent+0
;webserver.c,188 :: 		FAT32_ChangeDir("\\");
	LDI        R27, #lo_addr(?lstr9_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr9_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
;webserver.c,189 :: 		return 0;
	LDI        R16, 0
	LDI        R17, 0
	JMP        L_end_validateFile
;webserver.c,190 :: 		}
L_webserver_validateFile11:
;webserver.c,191 :: 		FAT32_ChangeDir("\\");
	LDI        R27, #lo_addr(?lstr10_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr10_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
;webserver.c,192 :: 		return 1;
	LDI        R16, 1
	LDI        R17, 0
	JMP        L_end_validateFile
;webserver.c,193 :: 		} else {
L_webserver_validateFile8:
;webserver.c,194 :: 		FAT32_ChangeDir("\\");
	LDI        R27, #lo_addr(?lstr11_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr11_webserver+0)
	MOV        R3, R27
	CALL       _FAT32_ChangeDir+0
;webserver.c,195 :: 		return 0;
	LDI        R16, 0
	LDI        R17, 0
;webserver.c,197 :: 		}
;webserver.c,195 :: 		return 0;
;webserver.c,197 :: 		}
L_end_validateFile:
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of webserver_validateFile

webserver_resetSocket:

;webserver.c,199 :: 		static void resetSocket(int socNum){
;webserver.c,200 :: 		webSoc[socNum].position = 0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R2
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 3
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
;webserver.c,201 :: 		webSoc[socNum].mark = 0;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R2
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, 0
	ST         Z, R27
;webserver.c,202 :: 		webSoc[socNum].bufPos = 0;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R2
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	SUBI       R30, 229
	SBCI       R31, 253
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
;webserver.c,203 :: 		if(Net_Ethernet_28j60_disconnectTCP(webSoc[socNum].socket) == 0){
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R2
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z+
	LD         R17, Z+
	MOVW       R2, R16
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
	CPI        R16, 0
	BREQ       L_webserver_resetSocket185
	JMP        L_webserver_resetSocket13
L_webserver_resetSocket185:
;webserver.c,204 :: 		logEvent(LOG_ERROR, "Failed to Close Socket\n");
	LDI        R27, #lo_addr(?lstr12_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr12_webserver+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _logEvent+0
;webserver.c,205 :: 		}
L_webserver_resetSocket13:
;webserver.c,206 :: 		}
L_end_resetSocket:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of webserver_resetSocket

webserver_codeTxt2RamTxt:

;webserver.c,208 :: 		static char *codeTxt2RamTxt(const char *ctxt){
;webserver.c,210 :: 		int i = 0;
;webserver.c,212 :: 		for(i =0; txt[i] = ctxt[i]; i++);
; i start address is: 20 (R20)
	LDI        R20, 0
	LDI        R21, 0
; i end address is: 20 (R20)
L_webserver_codeTxt2RamTxt14:
; i start address is: 20 (R20)
	LDI        R16, #lo_addr(webserver_codeTxt2RamTxt_txt_L0+0)
	LDI        R17, hi_addr(webserver_codeTxt2RamTxt_txt_L0+0)
	MOVW       R18, R20
	ADD        R18, R16
	ADC        R19, R17
	MOVW       R30, R20
	ADD        R30, R2
	ADC        R31, R3
	LPM        R16, Z
	MOVW       R30, R18
	ST         Z, R16
	MOVW       R30, R18
	LD         R16, Z
	TST        R16
	BRNE       L_webserver_codeTxt2RamTxt187
	JMP        L_webserver_codeTxt2RamTxt15
L_webserver_codeTxt2RamTxt187:
	MOVW       R16, R20
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R20, R16
; i end address is: 20 (R20)
	JMP        L_webserver_codeTxt2RamTxt14
L_webserver_codeTxt2RamTxt15:
;webserver.c,213 :: 		return &txt;
	LDI        R16, #lo_addr(webserver_codeTxt2RamTxt_txt_L0+0)
	LDI        R17, hi_addr(webserver_codeTxt2RamTxt_txt_L0+0)
;webserver.c,214 :: 		}
L_end_codeTxt2RamTxt:
	RET
; end of webserver_codeTxt2RamTxt

_Net_Ethernet_28j60_UserTCP:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SUBI       R28, 228
	SBCI       R29, 0
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;webserver.c,216 :: 		void Net_Ethernet_28j60_UserTCP(SOCKET_28j60_Dsc *socket) {
;webserver.c,217 :: 		if(status == READY){                                           // If SD Card is Ready, else a error_webpage is displayed
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	LDS        R27, _status+0
	SBRS       R27, BitPos(_status+0)
	JMP        L_Net_Ethernet_28j60_UserTCP17
;webserver.c,218 :: 		int i = 0;
;webserver.c,219 :: 		if(socket->destPort != portNumber){
	MOVW       R16, R2
	SUBI       R16, 244
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R18, Z+
	LD         R19, Z+
	LDS        R16, _portNumber+0
	CP         R18, R16
	LDI        R27, 0
	CPC        R19, R27
	BRNE       L__Net_Ethernet_28j60_UserTCP189
	JMP        L_Net_Ethernet_28j60_UserTCP18
L__Net_Ethernet_28j60_UserTCP189:
;webserver.c,220 :: 		return;                                              // Listen only to web requests on programmed port
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,221 :: 		} else {
L_Net_Ethernet_28j60_UserTCP18:
;webserver.c,222 :: 		char tmpChr = 0;
;webserver.c,224 :: 		char * const pRequest = &request;
	MOVW       R16, R28
	SUBI       R16, 132
	SBCI       R17, 255
; pRequest start address is: 18 (R18)
	MOVW       R18, R16
;webserver.c,225 :: 		memset(pRequest, 0, REQBUFFERSIZE);                  // Set the buffer to 0, keeps from having to set '\0' at the end of the string
	PUSH       R19
	PUSH       R18
	PUSH       R3
	PUSH       R2
	LDI        R27, 100
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	CLR        R4
	MOVW       R2, R16
	CALL       _memset+0
	POP        R2
	POP        R3
	POP        R18
	POP        R19
;webserver.c,227 :: 		for(i=0; i < REQBUFFERSIZE-1; i++){                  // Extract the request communication
; i start address is: 20 (R20)
	LDI        R20, 0
	LDI        R21, 0
; pRequest end address is: 18 (R18)
; i end address is: 20 (R20)
L_Net_Ethernet_28j60_UserTCP20:
; i start address is: 20 (R20)
; pRequest start address is: 18 (R18)
	LDI        R16, 99
	LDI        R17, 0
	CP         R20, R16
	CPC        R21, R17
	BRLT       L__Net_Ethernet_28j60_UserTCP190
	JMP        L_Net_Ethernet_28j60_UserTCP21
L__Net_Ethernet_28j60_UserTCP190:
;webserver.c,228 :: 		tmpChr = Net_Ethernet_28j60_getByte();
	PUSH       R19
	PUSH       R18
	PUSH       R21
	PUSH       R20
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_getByte+0
	POP        R2
	POP        R3
	POP        R20
	POP        R21
	POP        R18
	POP        R19
; tmpChr start address is: 22 (R22)
	MOV        R22, R16
;webserver.c,229 :: 		if(tmpChr == '\n') break;
	CPI        R16, 10
	BREQ       L__Net_Ethernet_28j60_UserTCP191
	JMP        L_Net_Ethernet_28j60_UserTCP23
L__Net_Ethernet_28j60_UserTCP191:
; tmpChr end address is: 22 (R22)
; i end address is: 20 (R20)
	JMP        L_Net_Ethernet_28j60_UserTCP21
L_Net_Ethernet_28j60_UserTCP23:
;webserver.c,230 :: 		else *(pRequest+i) = tmpChr;
; i start address is: 20 (R20)
; tmpChr start address is: 22 (R22)
	MOVW       R16, R20
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ST         Z, R22
; tmpChr end address is: 22 (R22)
;webserver.c,227 :: 		for(i=0; i < REQBUFFERSIZE-1; i++){                  // Extract the request communication
	MOVW       R16, R20
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R20, R16
;webserver.c,231 :: 		}
; i end address is: 20 (R20)
	JMP        L_Net_Ethernet_28j60_UserTCP20
L_Net_Ethernet_28j60_UserTCP21:
;webserver.c,233 :: 		if(memcmp(pRequest, "GET ", 3) == 0){                // If request is a GET, break the request down into tokens
	PUSH       R19
	PUSH       R18
	PUSH       R3
	PUSH       R2
	LDI        R27, 3
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	LDI        R27, #lo_addr(?lstr13_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr13_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
	CALL       _memcmp+0
	POP        R2
	POP        R3
	POP        R18
	POP        R19
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP192
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP192:
	BREQ       L__Net_Ethernet_28j60_UserTCP193
	JMP        L_Net_Ethernet_28j60_UserTCP25
L__Net_Ethernet_28j60_UserTCP193:
;webserver.c,235 :: 		char (*pCommands)[COMMANDSIZE] = &commands;
	MOVW       R16, R28
	SUBI       R16, 236
	SBCI       R17, 255
; pCommands start address is: 20 (R20)
	MOVW       R20, R16
;webserver.c,237 :: 		char * const pStrC = &strC;
	MOVW       R16, R28
	SUBI       R16, 145
	SBCI       R17, 255
; pStrC start address is: 22 (R22)
	MOVW       R22, R16
;webserver.c,238 :: 		int n = 0;
;webserver.c,240 :: 		strcpy(pStrC, strtok(pRequest, TOKENS));               // Get the first token
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr14_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr14_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
; pRequest end address is: 18 (R18)
	CALL       _strtok+0
	POP        R2
	POP        R3
	PUSH       R21
	PUSH       R20
	PUSH       R3
	PUSH       R2
	MOVW       R4, R16
	MOVW       R2, R22
	CALL       _strcpy+0
	POP        R2
	POP        R3
	POP        R20
	POP        R21
;webserver.c,241 :: 		for(n=0; (pStrC[0] != '\0') && (n < NUMCOMMAND); n++){ // If there are tokens left in the string set them here
; n start address is: 16 (R16)
	LDI        R16, 0
	LDI        R17, 0
; pCommands end address is: 20 (R20)
; n end address is: 16 (R16)
; pStrC end address is: 22 (R22)
	MOVW       R18, R20
	MOVW       R20, R16
L_Net_Ethernet_28j60_UserTCP26:
; n start address is: 20 (R20)
; pStrC start address is: 22 (R22)
; pCommands start address is: 18 (R18)
	MOVW       R30, R22
	LD         R16, Z
	CPI        R16, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP194
	JMP        L__Net_Ethernet_28j60_UserTCP148
L__Net_Ethernet_28j60_UserTCP194:
	LDI        R16, 7
	LDI        R17, 0
	CP         R20, R16
	CPC        R21, R17
	BRLT       L__Net_Ethernet_28j60_UserTCP195
	JMP        L__Net_Ethernet_28j60_UserTCP147
L__Net_Ethernet_28j60_UserTCP195:
L__Net_Ethernet_28j60_UserTCP146:
;webserver.c,242 :: 		strcpy(pCommands[n], pStrC);                      // Copy the token to a set of commands
	PUSH       R19
	PUSH       R18
	PUSH       R21
	PUSH       R20
	LDI        R16, 13
	LDI        R17, 0
	CALL       _HWMul_16x16+0
	POP        R20
	POP        R21
	POP        R18
	POP        R19
	ADD        R16, R18
	ADC        R17, R19
	PUSH       R19
	PUSH       R18
	PUSH       R21
	PUSH       R20
	PUSH       R3
	PUSH       R2
	MOVW       R4, R22
	MOVW       R2, R16
	CALL       _strcpy+0
	POP        R2
	POP        R3
	POP        R20
	POP        R21
;webserver.c,243 :: 		strcpy(pStrC, strtok(0, TOKENS));
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr15_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr15_webserver+0)
	MOV        R5, R27
	CLR        R2
	CLR        R3
	CALL       _strtok+0
	POP        R2
	POP        R3
	PUSH       R21
	PUSH       R20
	PUSH       R3
	PUSH       R2
	MOVW       R4, R16
	MOVW       R2, R22
	CALL       _strcpy+0
	POP        R2
	POP        R3
	POP        R20
	POP        R21
	POP        R18
	POP        R19
;webserver.c,241 :: 		for(n=0; (pStrC[0] != '\0') && (n < NUMCOMMAND); n++){ // If there are tokens left in the string set them here
	MOVW       R16, R20
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R20, R16
;webserver.c,244 :: 		}
; pStrC end address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP26
;webserver.c,241 :: 		for(n=0; (pStrC[0] != '\0') && (n < NUMCOMMAND); n++){ // If there are tokens left in the string set them here
L__Net_Ethernet_28j60_UserTCP148:
L__Net_Ethernet_28j60_UserTCP147:
;webserver.c,246 :: 		if((strcmp(pCommands[0], "GET") == 0) && socket->state != 3){
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr16_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr16_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
	CALL       _strcmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP196
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP196:
	BREQ       L__Net_Ethernet_28j60_UserTCP197
	JMP        L__Net_Ethernet_28j60_UserTCP150
L__Net_Ethernet_28j60_UserTCP197:
	MOVW       R16, R2
	SUBI       R16, 219
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	CPI        R16, 3
	BRNE       L__Net_Ethernet_28j60_UserTCP198
	JMP        L__Net_Ethernet_28j60_UserTCP149
L__Net_Ethernet_28j60_UserTCP198:
; pCommands end address is: 18 (R18)
; n end address is: 20 (R20)
L__Net_Ethernet_28j60_UserTCP145:
;webserver.c,247 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,246 :: 		if((strcmp(pCommands[0], "GET") == 0) && socket->state != 3){
L__Net_Ethernet_28j60_UserTCP150:
; n start address is: 20 (R20)
; pCommands start address is: 18 (R18)
L__Net_Ethernet_28j60_UserTCP149:
;webserver.c,248 :: 		} else if (strcmp(pCommands[0], "GET") == 0){
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr17_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr17_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
	CALL       _strcmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP199
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP199:
	BREQ       L__Net_Ethernet_28j60_UserTCP200
	JMP        L_Net_Ethernet_28j60_UserTCP35
L__Net_Ethernet_28j60_UserTCP200:
;webserver.c,250 :: 		char * const pFileStr = &fileStr;
	MOVW       R16, R28
	SUBI       R16, 249
	SBCI       R17, 255
; pFileStr start address is: 24 (R24)
	MOVW       R24, R16
;webserver.c,252 :: 		memset(pFileStr, 0, COMMANDSIZE);
	PUSH       R19
	PUSH       R18
	PUSH       R21
	PUSH       R20
	PUSH       R3
	PUSH       R2
	LDI        R27, 13
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	CLR        R4
	MOVW       R2, R16
	CALL       _memset+0
	POP        R2
	POP        R3
	POP        R20
	POP        R21
	POP        R18
	POP        R19
;webserver.c,253 :: 		for(i=0; i<n; i++){
; i start address is: 22 (R22)
	LDI        R22, 0
	LDI        R23, 0
; n end address is: 20 (R20)
; pFileStr end address is: 24 (R24)
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP36:
; i start address is: 22 (R22)
; pFileStr start address is: 24 (R24)
; pCommands start address is: 18 (R18)
; pCommands end address is: 18 (R18)
; n start address is: 20 (R20)
	CP         R22, R20
	CPC        R23, R21
	BRLT       L__Net_Ethernet_28j60_UserTCP201
	JMP        L_Net_Ethernet_28j60_UserTCP37
L__Net_Ethernet_28j60_UserTCP201:
; pCommands end address is: 18 (R18)
;webserver.c,254 :: 		if(strcmp(pCommands[i],"HTTP") == 0){
; pCommands start address is: 18 (R18)
	PUSH       R21
	PUSH       R20
	PUSH       R19
	PUSH       R18
	LDI        R16, 13
	LDI        R17, 0
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	POP        R18
	POP        R19
	POP        R20
	POP        R21
	ADD        R16, R18
	ADC        R17, R19
	PUSH       R3
	PUSH       R2
	LDI        R27, #lo_addr(?lstr18_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr18_webserver+0)
	MOV        R5, R27
	MOVW       R2, R16
	CALL       _strcmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP202
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP202:
	BREQ       L__Net_Ethernet_28j60_UserTCP203
	JMP        L__Net_Ethernet_28j60_UserTCP164
L__Net_Ethernet_28j60_UserTCP203:
;webserver.c,255 :: 		if(i == 1) {
	CPI        R23, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP204
	CPI        R22, 1
L__Net_Ethernet_28j60_UserTCP204:
	BREQ       L__Net_Ethernet_28j60_UserTCP205
	JMP        L_Net_Ethernet_28j60_UserTCP40
L__Net_Ethernet_28j60_UserTCP205:
;webserver.c,256 :: 		pFileStr = "index.htm";
	LDI        R24, #lo_addr(?lstr19_webserver+0)
	LDI        R25, hi_addr(?lstr19_webserver+0)
;webserver.c,257 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP41
; n end address is: 20 (R20)
L_Net_Ethernet_28j60_UserTCP40:
;webserver.c,258 :: 		strcpy(pFileStr, pCommands[i-1]);
	MOVW       R16, R22
	SUBI       R16, 1
	SBCI       R17, 0
; i end address is: 22 (R22)
	PUSH       R19
	PUSH       R18
	LDI        R20, 13
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	POP        R18
	POP        R19
	ADD        R16, R18
	ADC        R17, R19
; pCommands end address is: 18 (R18)
	PUSH       R3
	PUSH       R2
	MOVW       R4, R16
	MOVW       R2, R24
	CALL       _strcpy+0
	POP        R2
	POP        R3
;webserver.c,259 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP37
;webserver.c,260 :: 		}
L_Net_Ethernet_28j60_UserTCP41:
;webserver.c,261 :: 		}
; i start address is: 22 (R22)
; n start address is: 20 (R20)
; pFileStr end address is: 24 (R24)
; pCommands start address is: 18 (R18)
	JMP        L_Net_Ethernet_28j60_UserTCP39
L__Net_Ethernet_28j60_UserTCP164:
;webserver.c,254 :: 		if(strcmp(pCommands[i],"HTTP") == 0){
;webserver.c,261 :: 		}
L_Net_Ethernet_28j60_UserTCP39:
;webserver.c,253 :: 		for(i=0; i<n; i++){
; pFileStr start address is: 24 (R24)
	MOVW       R16, R22
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R22, R16
;webserver.c,262 :: 		}
; pCommands end address is: 18 (R18)
; n end address is: 20 (R20)
; i end address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP36
L_Net_Ethernet_28j60_UserTCP37:
;webserver.c,263 :: 		for(i = 0; i < MAX_SOCKETS; i++){
; i start address is: 22 (R22)
	LDI        R22, 0
	LDI        R23, 0
; pFileStr end address is: 24 (R24)
; i end address is: 22 (R22)
	MOVW       R20, R24
L_Net_Ethernet_28j60_UserTCP42:
; i start address is: 22 (R22)
; pFileStr start address is: 20 (R20)
; pFileStr start address is: 20 (R20)
; pFileStr end address is: 20 (R20)
	LDI        R16, 5
	LDI        R17, 0
	CP         R22, R16
	CPC        R23, R17
	BRLT       L__Net_Ethernet_28j60_UserTCP206
	JMP        L_Net_Ethernet_28j60_UserTCP43
L__Net_Ethernet_28j60_UserTCP206:
; pFileStr end address is: 20 (R20)
;webserver.c,264 :: 		if(webSoc[i].mark == 0 && webSoc[i].socket->open == 1){
; pFileStr start address is: 20 (R20)
	PUSH       R21
	PUSH       R20
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	POP        R20
	POP        R21
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 254
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	CPI        R16, 0
	BREQ       L__Net_Ethernet_28j60_UserTCP207
	JMP        L__Net_Ethernet_28j60_UserTCP152
L__Net_Ethernet_28j60_UserTCP207:
	PUSH       R21
	PUSH       R20
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	POP        R20
	POP        R21
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	SUBI       R16, 222
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	CPI        R16, 1
	BREQ       L__Net_Ethernet_28j60_UserTCP208
	JMP        L__Net_Ethernet_28j60_UserTCP151
L__Net_Ethernet_28j60_UserTCP208:
L__Net_Ethernet_28j60_UserTCP144:
;webserver.c,270 :: 		fEnd = strchr(pFileStr, '.');        // Lets see what the extension is!
	PUSH       R3
	PUSH       R2
	LDI        R27, 46
	MOV        R4, R27
	MOVW       R2, R20
	CALL       _strchr+0
; fEnd start address is: 18 (R18)
	MOVW       R18, R16
;webserver.c,272 :: 		if(strncmp(fEnd, ".htm", 3) == 0){   // Behavior is based on file extension
	LDI        R27, 3
	MOV        R6, R27
	LDI        R27, #lo_addr(?lstr20_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr20_webserver+0)
	MOV        R5, R27
	MOVW       R2, R16
	CALL       _strncmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP209
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP209:
	BREQ       L__Net_Ethernet_28j60_UserTCP210
	JMP        L_Net_Ethernet_28j60_UserTCP48
L__Net_Ethernet_28j60_UserTCP210:
; fEnd end address is: 18 (R18)
;webserver.c,273 :: 		if(validateFile(FILE_HTML, i ,pFileStr)){
	PUSH       R23
	PUSH       R22
; pFileStr end address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	MOVW       R6, R20
	MOVW       R4, R22
	CLR        R2
	CLR        R3
	CALL       webserver_validateFile+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__Net_Ethernet_28j60_UserTCP211
	JMP        L_Net_Ethernet_28j60_UserTCP49
L__Net_Ethernet_28j60_UserTCP211:
;webserver.c,274 :: 		webSoc[i].socket = socket;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ST         Z+, R2
	ST         Z+, R3
;webserver.c,275 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP50
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP49:
;webserver.c,276 :: 		Net_Ethernet_28j60_disconnectTCP(socket);
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
	POP        R2
	POP        R3
;webserver.c,277 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,278 :: 		}
L_Net_Ethernet_28j60_UserTCP50:
;webserver.c,279 :: 		} else if(strncmp(fEnd, ".css", 3) == 0){
; i start address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP51
L_Net_Ethernet_28j60_UserTCP48:
; fEnd start address is: 18 (R18)
; pFileStr start address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	LDI        R27, 3
	MOV        R6, R27
	LDI        R27, #lo_addr(?lstr21_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr21_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
	CALL       _strncmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP212
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP212:
	BREQ       L__Net_Ethernet_28j60_UserTCP213
	JMP        L_Net_Ethernet_28j60_UserTCP52
L__Net_Ethernet_28j60_UserTCP213:
; fEnd end address is: 18 (R18)
;webserver.c,280 :: 		if(validateFile(FILE_CSS, i ,pFileStr)){
	PUSH       R23
	PUSH       R22
; pFileStr end address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	MOVW       R6, R20
	MOVW       R4, R22
	LDI        R27, 1
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       webserver_validateFile+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__Net_Ethernet_28j60_UserTCP214
	JMP        L_Net_Ethernet_28j60_UserTCP53
L__Net_Ethernet_28j60_UserTCP214:
;webserver.c,281 :: 		webSoc[i].socket = socket;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ST         Z+, R2
	ST         Z+, R3
;webserver.c,282 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP54
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP53:
;webserver.c,283 :: 		Net_Ethernet_28j60_disconnectTCP(socket);
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
	POP        R2
	POP        R3
;webserver.c,284 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,285 :: 		}
L_Net_Ethernet_28j60_UserTCP54:
;webserver.c,286 :: 		} else if(strncmp(fEnd, ".js", 3) == 0){
; i start address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP55
L_Net_Ethernet_28j60_UserTCP52:
; fEnd start address is: 18 (R18)
; pFileStr start address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	LDI        R27, 3
	MOV        R6, R27
	LDI        R27, #lo_addr(?lstr22_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr22_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
	CALL       _strncmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP215
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP215:
	BREQ       L__Net_Ethernet_28j60_UserTCP216
	JMP        L_Net_Ethernet_28j60_UserTCP56
L__Net_Ethernet_28j60_UserTCP216:
; fEnd end address is: 18 (R18)
;webserver.c,287 :: 		if(validateFile(FILE_JS, i ,pFileStr)){
	PUSH       R23
	PUSH       R22
; pFileStr end address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	MOVW       R6, R20
	MOVW       R4, R22
	LDI        R27, 2
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       webserver_validateFile+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__Net_Ethernet_28j60_UserTCP217
	JMP        L_Net_Ethernet_28j60_UserTCP57
L__Net_Ethernet_28j60_UserTCP217:
;webserver.c,288 :: 		webSoc[i].socket = socket;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ST         Z+, R2
	ST         Z+, R3
;webserver.c,289 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP58
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP57:
;webserver.c,290 :: 		Net_Ethernet_28j60_disconnectTCP(socket);
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
	POP        R2
	POP        R3
;webserver.c,291 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,292 :: 		}
L_Net_Ethernet_28j60_UserTCP58:
;webserver.c,293 :: 		} else if(strncmp(fEnd, ".jpg", 3) == 0){
; i start address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP59
L_Net_Ethernet_28j60_UserTCP56:
; fEnd start address is: 18 (R18)
; pFileStr start address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	LDI        R27, 3
	MOV        R6, R27
	LDI        R27, #lo_addr(?lstr23_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr23_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
	CALL       _strncmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP218
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP218:
	BREQ       L__Net_Ethernet_28j60_UserTCP219
	JMP        L_Net_Ethernet_28j60_UserTCP60
L__Net_Ethernet_28j60_UserTCP219:
; fEnd end address is: 18 (R18)
;webserver.c,294 :: 		if(validateFile(FILE_JPG, i ,pFileStr)){
	PUSH       R23
	PUSH       R22
; pFileStr end address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	MOVW       R6, R20
	MOVW       R4, R22
	LDI        R27, 5
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       webserver_validateFile+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__Net_Ethernet_28j60_UserTCP220
	JMP        L_Net_Ethernet_28j60_UserTCP61
L__Net_Ethernet_28j60_UserTCP220:
;webserver.c,295 :: 		webSoc[i].socket = socket;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ST         Z+, R2
	ST         Z+, R3
;webserver.c,296 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP62
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP61:
;webserver.c,297 :: 		Net_Ethernet_28j60_disconnectTCP(socket);
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
	POP        R2
	POP        R3
;webserver.c,298 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,299 :: 		}
L_Net_Ethernet_28j60_UserTCP62:
;webserver.c,300 :: 		} else if(strncmp(fEnd, ".png", 3) == 0){
; i start address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP63
L_Net_Ethernet_28j60_UserTCP60:
; fEnd start address is: 18 (R18)
; pFileStr start address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	LDI        R27, 3
	MOV        R6, R27
	LDI        R27, #lo_addr(?lstr24_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr24_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
	CALL       _strncmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP221
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP221:
	BREQ       L__Net_Ethernet_28j60_UserTCP222
	JMP        L_Net_Ethernet_28j60_UserTCP64
L__Net_Ethernet_28j60_UserTCP222:
; fEnd end address is: 18 (R18)
;webserver.c,301 :: 		if(validateFile(FILE_PNG, i ,pFileStr)){
	PUSH       R23
	PUSH       R22
; pFileStr end address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	MOVW       R6, R20
	MOVW       R4, R22
	LDI        R27, 3
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       webserver_validateFile+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__Net_Ethernet_28j60_UserTCP223
	JMP        L_Net_Ethernet_28j60_UserTCP65
L__Net_Ethernet_28j60_UserTCP223:
;webserver.c,302 :: 		webSoc[i].socket = socket;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ST         Z+, R2
	ST         Z+, R3
;webserver.c,303 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP66
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP65:
;webserver.c,304 :: 		Net_Ethernet_28j60_disconnectTCP(socket);
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
	POP        R2
	POP        R3
;webserver.c,305 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,306 :: 		}
L_Net_Ethernet_28j60_UserTCP66:
;webserver.c,307 :: 		} else if(strncmp(fEnd, ".ico", 3) == 0){
; i start address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP67
L_Net_Ethernet_28j60_UserTCP64:
; fEnd start address is: 18 (R18)
; pFileStr start address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	LDI        R27, 3
	MOV        R6, R27
	LDI        R27, #lo_addr(?lstr25_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr25_webserver+0)
	MOV        R5, R27
	MOVW       R2, R18
; fEnd end address is: 18 (R18)
	CALL       _strncmp+0
	POP        R2
	POP        R3
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP224
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP224:
	BREQ       L__Net_Ethernet_28j60_UserTCP225
	JMP        L_Net_Ethernet_28j60_UserTCP68
L__Net_Ethernet_28j60_UserTCP225:
;webserver.c,308 :: 		if(validateFile(FILE_ICO, i ,pFileStr)){
	PUSH       R23
	PUSH       R22
; pFileStr end address is: 20 (R20)
	PUSH       R3
	PUSH       R2
	MOVW       R6, R20
	MOVW       R4, R22
	LDI        R27, 4
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       webserver_validateFile+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__Net_Ethernet_28j60_UserTCP226
	JMP        L_Net_Ethernet_28j60_UserTCP69
L__Net_Ethernet_28j60_UserTCP226:
;webserver.c,309 :: 		webSoc[i].socket = socket;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ST         Z+, R2
	ST         Z+, R3
;webserver.c,310 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP70
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP69:
;webserver.c,311 :: 		Net_Ethernet_28j60_disconnectTCP(socket);
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
	POP        R2
	POP        R3
;webserver.c,312 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,313 :: 		}
L_Net_Ethernet_28j60_UserTCP70:
;webserver.c,314 :: 		} else {
; i start address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP71
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP68:
;webserver.c,315 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,316 :: 		}
L_Net_Ethernet_28j60_UserTCP71:
; i start address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP67:
L_Net_Ethernet_28j60_UserTCP63:
L_Net_Ethernet_28j60_UserTCP59:
L_Net_Ethernet_28j60_UserTCP55:
L_Net_Ethernet_28j60_UserTCP51:
;webserver.c,318 :: 		Net_Ethernet_28j60_putConstStringTCP(httpHead, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpHead+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpHead+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpHead+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,319 :: 		Net_Ethernet_28j60_putConstStringTCP(httpServer, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpServer+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpServer+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpServer+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,320 :: 		Net_Ethernet_28j60_putConstStringTCP(httpDate, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpDate+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpDate+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpDate+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,321 :: 		Net_Ethernet_28j60_putConstStringTCP(httpConnectionClose, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpConnectionClose+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpConnectionClose+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpConnectionClose+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,322 :: 		Net_Ethernet_28j60_putConstStringTCP(httpContentLength, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpContentLength+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentLength+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentLength+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,323 :: 		LongToStr(webSoc[i].fileSize, txt);                         // Convert the size of the file to string
	MOVW       R16, R28
	MOVW       R30, R28
	SUBI       R30, 30
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 233
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R18, Z+
	LD         R19, Z+
	LD         R20, Z+
	LD         R21, Z+
	MOVW       R30, R28
	SUBI       R30, 30
	SBCI       R31, 255
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	MOVW       R2, R18
	MOVW       R4, R20
	CALL       _LongToStr+0
;webserver.c,324 :: 		res = Ltrim(txt);                                           // Trims the filesize to eliminate pre '\0's
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _Ltrim+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
; res start address is: 20 (R20)
	MOVW       R20, R16
;webserver.c,325 :: 		Net_Ethernet_28j60_putStringTCP(res, webSoc[i].socket);
	PUSH       R21
	PUSH       R20
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	POP        R20
	POP        R21
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R4, R16
	MOVW       R2, R20
; res end address is: 20 (R20)
	CALL       _Net_Ethernet_28j60_putStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,326 :: 		Net_Ethernet_28j60_putByteTCP('\n', webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOV        R3, R16
	MOV        R4, R17
	LDI        R27, 10
	MOV        R2, R27
	CALL       _Net_Ethernet_28j60_putByteTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,327 :: 		switch(webSoc[i].fileType){
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 235
	SBCI       R17, 255
	MOVW       R30, R28
	SUBI       R30, 30
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	JMP        L_Net_Ethernet_28j60_UserTCP72
;webserver.c,328 :: 		case FILE_HTML:
L_Net_Ethernet_28j60_UserTCP74:
;webserver.c,329 :: 		Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpContentType+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentType+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentType+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,330 :: 		Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeHTML, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
; i end address is: 22 (R22)
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpMimeTypeHTML+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpMimeTypeHTML+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpMimeTypeHTML+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
;webserver.c,331 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP73
;webserver.c,332 :: 		case FILE_CSS:
L_Net_Ethernet_28j60_UserTCP75:
;webserver.c,333 :: 		Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
; i start address is: 22 (R22)
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpContentType+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentType+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentType+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,334 :: 		Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeCSS, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
; i end address is: 22 (R22)
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpMimeTypeCSS+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpMimeTypeCSS+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpMimeTypeCSS+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
;webserver.c,335 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP73
;webserver.c,336 :: 		case FILE_JS:
L_Net_Ethernet_28j60_UserTCP76:
;webserver.c,337 :: 		Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
; i start address is: 22 (R22)
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpContentType+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentType+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentType+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,338 :: 		Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeJS, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
; i end address is: 22 (R22)
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpMimeTypeJS+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpMimeTypeJS+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpMimeTypeJS+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
;webserver.c,339 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP73
;webserver.c,340 :: 		case FILE_PNG:
L_Net_Ethernet_28j60_UserTCP77:
;webserver.c,341 :: 		Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
; i start address is: 22 (R22)
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpContentType+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentType+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentType+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,342 :: 		Net_Ethernet_28j60_putConstStringTCP(httpMimeTypePNG, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
; i end address is: 22 (R22)
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpMimeTypePNG+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpMimeTypePNG+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpMimeTypePNG+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
;webserver.c,343 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP73
;webserver.c,344 :: 		case FILE_JPG:
L_Net_Ethernet_28j60_UserTCP78:
;webserver.c,345 :: 		Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
; i start address is: 22 (R22)
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpContentType+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentType+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentType+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,346 :: 		Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeJPG, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
; i end address is: 22 (R22)
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpMimeTypeJPG+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpMimeTypeJPG+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpMimeTypeJPG+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
;webserver.c,347 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP73
;webserver.c,348 :: 		case FILE_ICO:
L_Net_Ethernet_28j60_UserTCP79:
;webserver.c,349 :: 		Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
; i start address is: 22 (R22)
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R23
	PUSH       R22
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpContentType+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentType+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentType+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	POP        R22
	POP        R23
;webserver.c,350 :: 		Net_Ethernet_28j60_putConstStringTCP(httpMimeTypePNG, webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R22
	CALL       _HWMul_16x16+0
; i end address is: 22 (R22)
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R3
	PUSH       R2
	MOVW       R6, R16
	LDI        R27, #lo_addr(_httpMimeTypePNG+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpMimeTypePNG+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpMimeTypePNG+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
;webserver.c,351 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP73
;webserver.c,352 :: 		}
L_Net_Ethernet_28j60_UserTCP72:
; i start address is: 22 (R22)
	MOVW       R30, R28
	SUBI       R30, 30
	SBCI       R31, 255
	LD         R18, Z+
	LD         R19, Z+
	MOVW       R30, R18
	LD         R16, Z+
	LD         R17, Z+
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP227
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP227:
	BRNE       L__Net_Ethernet_28j60_UserTCP228
	JMP        L_Net_Ethernet_28j60_UserTCP74
L__Net_Ethernet_28j60_UserTCP228:
	MOVW       R30, R18
	LD         R16, Z+
	LD         R17, Z+
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP229
	CPI        R16, 1
L__Net_Ethernet_28j60_UserTCP229:
	BRNE       L__Net_Ethernet_28j60_UserTCP230
	JMP        L_Net_Ethernet_28j60_UserTCP75
L__Net_Ethernet_28j60_UserTCP230:
	MOVW       R30, R18
	LD         R16, Z+
	LD         R17, Z+
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP231
	CPI        R16, 2
L__Net_Ethernet_28j60_UserTCP231:
	BRNE       L__Net_Ethernet_28j60_UserTCP232
	JMP        L_Net_Ethernet_28j60_UserTCP76
L__Net_Ethernet_28j60_UserTCP232:
	MOVW       R30, R18
	LD         R16, Z+
	LD         R17, Z+
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP233
	CPI        R16, 3
L__Net_Ethernet_28j60_UserTCP233:
	BRNE       L__Net_Ethernet_28j60_UserTCP234
	JMP        L_Net_Ethernet_28j60_UserTCP77
L__Net_Ethernet_28j60_UserTCP234:
	MOVW       R30, R18
	LD         R16, Z+
	LD         R17, Z+
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP235
	CPI        R16, 5
L__Net_Ethernet_28j60_UserTCP235:
	BRNE       L__Net_Ethernet_28j60_UserTCP236
	JMP        L_Net_Ethernet_28j60_UserTCP78
L__Net_Ethernet_28j60_UserTCP236:
	MOVW       R30, R18
	LD         R16, Z+
	LD         R17, Z+
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP237
	CPI        R16, 4
L__Net_Ethernet_28j60_UserTCP237:
	BRNE       L__Net_Ethernet_28j60_UserTCP238
	JMP        L_Net_Ethernet_28j60_UserTCP79
L__Net_Ethernet_28j60_UserTCP238:
; i end address is: 22 (R22)
L_Net_Ethernet_28j60_UserTCP73:
;webserver.c,353 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP43
;webserver.c,264 :: 		if(webSoc[i].mark == 0 && webSoc[i].socket->open == 1){
L__Net_Ethernet_28j60_UserTCP152:
; i start address is: 22 (R22)
; pFileStr start address is: 20 (R20)
L__Net_Ethernet_28j60_UserTCP151:
;webserver.c,263 :: 		for(i = 0; i < MAX_SOCKETS; i++){
	MOVW       R16, R22
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R22, R16
;webserver.c,355 :: 		}
; pFileStr end address is: 20 (R20)
; i end address is: 22 (R22)
	JMP        L_Net_Ethernet_28j60_UserTCP42
L_Net_Ethernet_28j60_UserTCP43:
;webserver.c,356 :: 		}
L_Net_Ethernet_28j60_UserTCP35:
;webserver.c,357 :: 		}
L_Net_Ethernet_28j60_UserTCP25:
;webserver.c,361 :: 		for(i = 0; i < MAX_SOCKETS; i++){
; i start address is: 4 (R4)
	CLR        R4
	CLR        R5
; i end address is: 4 (R4)
L_Net_Ethernet_28j60_UserTCP80:
; i start address is: 4 (R4)
	LDI        R16, 5
	LDI        R17, 0
	CP         R4, R16
	CPC        R5, R17
	BRLT       L__Net_Ethernet_28j60_UserTCP239
	JMP        L_Net_Ethernet_28j60_UserTCP81
L__Net_Ethernet_28j60_UserTCP239:
;webserver.c,362 :: 		if((webSoc[i].mark == 1) && (webSoc[i].socket == socket)){
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 254
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	CPI        R16, 1
	BREQ       L__Net_Ethernet_28j60_UserTCP240
	JMP        L__Net_Ethernet_28j60_UserTCP165
L__Net_Ethernet_28j60_UserTCP240:
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	CP         R16, R2
	CPC        R17, R3
	BREQ       L__Net_Ethernet_28j60_UserTCP241
	JMP        L__Net_Ethernet_28j60_UserTCP166
L__Net_Ethernet_28j60_UserTCP241:
L__Net_Ethernet_28j60_UserTCP143:
;webserver.c,363 :: 		while(webSoc[i].position < webSoc[i].fileSize){
L_Net_Ethernet_28j60_UserTCP86:
; i end address is: 4 (R4)
; i start address is: 4 (R4)
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	MOVW       R24, R16
	ADD        R24, R18
	ADC        R25, R19
	MOVW       R16, R24
	SUBI       R16, 253
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R20, Z+
	LD         R21, Z+
	LD         R22, Z+
	LD         R23, Z+
	MOVW       R16, R24
	SUBI       R16, 233
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRLO       L__Net_Ethernet_28j60_UserTCP242
	JMP        L_Net_Ethernet_28j60_UserTCP87
L__Net_Ethernet_28j60_UserTCP242:
;webserver.c,364 :: 		if((webSoc[i].bufPos == DATABUFFERSIZE) && (FAT32_Eof(webSoc[i].fileHandle) != 1)) {
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 229
	SBCI       R17, 253
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	CPI        R17, 2
	BRNE       L__Net_Ethernet_28j60_UserTCP243
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP243:
	BREQ       L__Net_Ethernet_28j60_UserTCP244
	JMP        L__Net_Ethernet_28j60_UserTCP154
L__Net_Ethernet_28j60_UserTCP244:
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 236
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _FAT32_Eof+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	CPI        R16, 1
	BRNE       L__Net_Ethernet_28j60_UserTCP245
	JMP        L__Net_Ethernet_28j60_UserTCP153
L__Net_Ethernet_28j60_UserTCP245:
L__Net_Ethernet_28j60_UserTCP142:
;webserver.c,365 :: 		FAT32_Read(webSoc[i].fileHandle, &webSoc[i].buffer, DATABUFFERSIZE);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R18, R16
	SUBI       R18, 229
	SBCI       R19, 255
	SUBI       R16, 236
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, 0
	MOV        R5, R27
	LDI        R27, 2
	MOV        R6, R27
	MOV        R3, R18
	MOV        R4, R19
	MOV        R2, R16
	CALL       _FAT32_Read+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;webserver.c,366 :: 		webSoc[i].bufPos = 0;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 229
	SBCI       R17, 253
	MOVW       R30, R16
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
;webserver.c,364 :: 		if((webSoc[i].bufPos == DATABUFFERSIZE) && (FAT32_Eof(webSoc[i].fileHandle) != 1)) {
L__Net_Ethernet_28j60_UserTCP154:
L__Net_Ethernet_28j60_UserTCP153:
;webserver.c,368 :: 		if(FAT32_Eof(webSoc[i].fileHandle) == 1) {
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 236
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _FAT32_Eof+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	CPI        R16, 1
	BREQ       L__Net_Ethernet_28j60_UserTCP246
	JMP        L_Net_Ethernet_28j60_UserTCP91
L__Net_Ethernet_28j60_UserTCP246:
;webserver.c,369 :: 		FAT32_Close(webSoc[i].fileHandle);
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 236
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _FAT32_Close+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;webserver.c,370 :: 		}
L_Net_Ethernet_28j60_UserTCP91:
;webserver.c,371 :: 		switch(Net_Ethernet_28j60_putByteTCP(webSoc[i].buffer[webSoc[i].bufPos], webSoc[i].socket)){
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R20, Z+
	LD         R21, Z+
	MOVW       R18, R16
	SUBI       R18, 229
	SBCI       R19, 255
	SUBI       R16, 229
	SBCI       R17, 253
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOV        R3, R20
	MOV        R4, R21
	MOV        R2, R16
	CALL       _Net_Ethernet_28j60_putByteTCP+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	MOVW       R30, R28
	SUBI       R30, 30
	SBCI       R31, 255
	ST         Z, R16
	JMP        L_Net_Ethernet_28j60_UserTCP92
;webserver.c,372 :: 		case 1:
L_Net_Ethernet_28j60_UserTCP94:
;webserver.c,373 :: 		webSoc[i].bufPos++; webSoc[i].position++;
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R18, R16
	SUBI       R18, 229
	SBCI       R19, 253
	MOVW       R30, R18
	LD         R16, Z+
	LD         R17, Z+
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R30, R18
	ST         Z+, R16
	ST         Z+, R17
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R20, R16
	SUBI       R20, 253
	SBCI       R21, 255
	MOVW       R30, R20
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	MOVW       R30, R20
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
;webserver.c,374 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP93
; i end address is: 4 (R4)
;webserver.c,375 :: 		case 0:
L_Net_Ethernet_28j60_UserTCP95:
;webserver.c,376 :: 		return;
	JMP        L_end_Net_Ethernet_28j60_UserTCP
;webserver.c,378 :: 		}
L_Net_Ethernet_28j60_UserTCP92:
; i start address is: 4 (R4)
	MOVW       R30, R28
	SUBI       R30, 30
	SBCI       R31, 255
	LD         R16, Z
	CPI        R16, 1
	BRNE       L__Net_Ethernet_28j60_UserTCP247
	JMP        L_Net_Ethernet_28j60_UserTCP94
L__Net_Ethernet_28j60_UserTCP247:
	CPI        R16, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP248
	JMP        L_Net_Ethernet_28j60_UserTCP95
L__Net_Ethernet_28j60_UserTCP248:
L_Net_Ethernet_28j60_UserTCP93:
;webserver.c,379 :: 		}
	JMP        L_Net_Ethernet_28j60_UserTCP86
L_Net_Ethernet_28j60_UserTCP87:
;webserver.c,380 :: 		if((Net_Ethernet_28j60_bufferEmptyTCP(webSoc[i].socket) == 1) && webSoc[i].position >= webSoc[i].fileSize){
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z+
	LD         R17, Z+
	PUSH       R3
	PUSH       R2
	MOVW       R2, R16
	CALL       _Net_Ethernet_28j60_bufferEmptyTCP+0
	POP        R2
	POP        R3
	CPI        R16, 1
	BREQ       L__Net_Ethernet_28j60_UserTCP249
	JMP        L__Net_Ethernet_28j60_UserTCP156
L__Net_Ethernet_28j60_UserTCP249:
	LDI        R16, 29
	LDI        R17, 2
	MOVW       R20, R4
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R24, R16
	ADIW       R24, 3
	SUBI       R16, 233
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R20, Z+
	LD         R21, Z+
	LD         R22, Z+
	LD         R23, Z+
	MOVW       R30, R24
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRSH       L__Net_Ethernet_28j60_UserTCP250
	JMP        L__Net_Ethernet_28j60_UserTCP155
L__Net_Ethernet_28j60_UserTCP250:
L__Net_Ethernet_28j60_UserTCP141:
;webserver.c,381 :: 		resetSocket(i);
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOVW       R2, R4
	CALL       webserver_resetSocket+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;webserver.c,380 :: 		if((Net_Ethernet_28j60_bufferEmptyTCP(webSoc[i].socket) == 1) && webSoc[i].position >= webSoc[i].fileSize){
L__Net_Ethernet_28j60_UserTCP156:
L__Net_Ethernet_28j60_UserTCP155:
;webserver.c,362 :: 		if((webSoc[i].mark == 1) && (webSoc[i].socket == socket)){
	MOVW       R18, R4
	JMP        L__Net_Ethernet_28j60_UserTCP158
; i end address is: 4 (R4)
L__Net_Ethernet_28j60_UserTCP165:
	MOVW       R18, R4
L__Net_Ethernet_28j60_UserTCP158:
; i start address is: 18 (R18)
; i end address is: 18 (R18)
	JMP        L__Net_Ethernet_28j60_UserTCP157
L__Net_Ethernet_28j60_UserTCP166:
	MOVW       R18, R4
L__Net_Ethernet_28j60_UserTCP157:
;webserver.c,361 :: 		for(i = 0; i < MAX_SOCKETS; i++){
; i start address is: 18 (R18)
	MOVW       R16, R18
	SUBI       R16, 255
	SBCI       R17, 255
; i end address is: 18 (R18)
; i start address is: 4 (R4)
	MOVW       R4, R16
;webserver.c,384 :: 		}
; i end address is: 4 (R4)
	JMP        L_Net_Ethernet_28j60_UserTCP80
L_Net_Ethernet_28j60_UserTCP81:
;webserver.c,386 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP99
L_Net_Ethernet_28j60_UserTCP17:
;webserver.c,389 :: 		if(webSoc[FILE_HTML].position == 0){
	LDS        R16, _webSoc+3
	LDS        R17, _webSoc+4
	LDS        R18, _webSoc+5
	LDS        R19, _webSoc+6
	CPI        R19, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP251
	CPI        R18, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP251
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserTCP251
	CPI        R16, 0
L__Net_Ethernet_28j60_UserTCP251:
	BREQ       L__Net_Ethernet_28j60_UserTCP252
	JMP        L_Net_Ethernet_28j60_UserTCP100
L__Net_Ethernet_28j60_UserTCP252:
;webserver.c,390 :: 		webSoc[FILE_HTML].mark = 1;
	LDI        R27, 1
	STS        _webSoc+2, R27
;webserver.c,391 :: 		webSoc[FILE_HTML].socket = socket;
	STS        _webSoc+0, R2
	STS        _webSoc+1, R3
;webserver.c,392 :: 		webSoc[FILE_HTML].bufPos = 0;
	LDI        R27, 0
	STS        _webSoc+539, R27
	STS        _webSoc+540, R27
;webserver.c,393 :: 		webSoc[FILE_HTML].fileSize = 264;
	LDI        R27, 8
	STS        _webSoc+23, R27
	LDI        R27, 1
	STS        _webSoc+24, R27
	LDI        R27, 0
	STS        _webSoc+25, R27
	STS        _webSoc+26, R27
;webserver.c,394 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpHead, webSoc[FILE_HTML].socket);
	PUSH       R3
	PUSH       R2
	LDS        R6, _webSoc+0
	LDS        R7, _webSoc+1
	LDI        R27, #lo_addr(_httpHead+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpHead+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpHead+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,395 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpServer, webSoc[FILE_HTML].socket);
	LDS        R6, _webSoc+0
	LDS        R7, _webSoc+1
	LDI        R27, #lo_addr(_httpServer+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpServer+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpServer+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,396 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpDate, webSoc[FILE_HTML].socket);
	LDS        R6, _webSoc+0
	LDS        R7, _webSoc+1
	LDI        R27, #lo_addr(_httpDate+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpDate+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpDate+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,397 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpConnectionClose, webSoc[FILE_HTML].socket);
	LDS        R6, _webSoc+0
	LDS        R7, _webSoc+1
	LDI        R27, #lo_addr(_httpConnectionClose+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpConnectionClose+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpConnectionClose+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,398 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpContentLength, webSoc[FILE_HTML].socket);
	LDS        R6, _webSoc+0
	LDS        R7, _webSoc+1
	LDI        R27, #lo_addr(_httpContentLength+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentLength+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentLength+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,399 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putStringTCP("264", webSoc[FILE_HTML].socket);
	LDS        R4, _webSoc+0
	LDS        R5, _webSoc+1
	LDI        R27, #lo_addr(?lstr26_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr26_webserver+0)
	MOV        R3, R27
	CALL       _Net_Ethernet_28j60_putStringTCP+0
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,400 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putByteTCP('\n', webSoc[FILE_HTML].socket);
	LDS        R3, _webSoc+0
	LDS        R4, _webSoc+1
	LDI        R27, 10
	MOV        R2, R27
	CALL       _Net_Ethernet_28j60_putByteTCP+0
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,401 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[FILE_HTML].socket);
	LDS        R6, _webSoc+0
	LDS        R7, _webSoc+1
	LDI        R27, #lo_addr(_httpContentType+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpContentType+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpContentType+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,402 :: 		webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeHTML, webSoc[FILE_HTML].socket);
	LDS        R6, _webSoc+0
	LDS        R7, _webSoc+1
	LDI        R27, #lo_addr(_httpMimeTypeHTML+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_httpMimeTypeHTML+0)
	MOV        R3, R27
	LDI        R27, higher_addr(_httpMimeTypeHTML+0)
	MOV        R4, R27
	MOV        R5, R4
	CALL       _Net_Ethernet_28j60_putConstStringTCP+0
	POP        R2
	POP        R3
	LDS        R20, _webSoc+3
	LDS        R21, _webSoc+4
	LDS        R22, _webSoc+5
	LDS        R23, _webSoc+6
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,403 :: 		}
L_Net_Ethernet_28j60_UserTCP100:
;webserver.c,405 :: 		while(webSoc[FILE_HTML].bufPos < webSoc[FILE_HTML].fileSize && socket == webSoc[FILE_HTML].socket) {
L_Net_Ethernet_28j60_UserTCP101:
	LDS        R16, _webSoc+539
	LDS        R17, _webSoc+540
	LDS        R20, _webSoc+23
	LDS        R21, _webSoc+24
	LDS        R22, _webSoc+25
	LDS        R23, _webSoc+26
	LDI        R18, 0
	MOV        R19, R18
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLO       L__Net_Ethernet_28j60_UserTCP253
	JMP        L__Net_Ethernet_28j60_UserTCP160
L__Net_Ethernet_28j60_UserTCP253:
	LDS        R16, _webSoc+0
	LDS        R17, _webSoc+1
	CP         R2, R16
	CPC        R3, R17
	BREQ       L__Net_Ethernet_28j60_UserTCP254
	JMP        L__Net_Ethernet_28j60_UserTCP159
L__Net_Ethernet_28j60_UserTCP254:
L__Net_Ethernet_28j60_UserTCP140:
;webserver.c,406 :: 		*p = errorPage[webSoc[FILE_HTML].bufPos];
	LDI        R18, #lo_addr(_errorPage+0)
	LDI        R19, hi_addr(_errorPage+0)
	LDS        R16, _webSoc+539
	LDS        R17, _webSoc+540
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LPM        R16, Z
	MOVW       R30, R28
	SUBI       R30, 32
	SBCI       R31, 255
	LD         R0, Z+
	LD         R1, Z+
	MOVW       R30, R0
	ST         Z, R16
;webserver.c,407 :: 		if(Net_Ethernet_28j60_putByteTCP(*p, webSoc[FILE_HTML].socket) == 1){
	MOVW       R30, R28
	SUBI       R30, 32
	SBCI       R31, 255
	LD         R0, Z+
	LD         R1, Z+
	MOVW       R30, R0
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	LDS        R3, _webSoc+0
	LDS        R4, _webSoc+1
	MOV        R2, R16
	CALL       _Net_Ethernet_28j60_putByteTCP+0
	POP        R2
	POP        R3
	CPI        R16, 1
	BREQ       L__Net_Ethernet_28j60_UserTCP255
	JMP        L_Net_Ethernet_28j60_UserTCP105
L__Net_Ethernet_28j60_UserTCP255:
;webserver.c,408 :: 		webSoc[FILE_HTML].position++;
	LDS        R16, _webSoc+3
	LDS        R17, _webSoc+4
	LDS        R18, _webSoc+5
	LDS        R19, _webSoc+6
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _webSoc+3, R16
	STS        _webSoc+4, R17
	STS        _webSoc+5, R18
	STS        _webSoc+6, R19
;webserver.c,409 :: 		webSoc[FILE_HTML].bufPos++;
	LDS        R16, _webSoc+539
	LDS        R17, _webSoc+540
	SUBI       R16, 255
	SBCI       R17, 255
	STS        _webSoc+539, R16
	STS        _webSoc+540, R17
;webserver.c,410 :: 		} else {
	JMP        L_Net_Ethernet_28j60_UserTCP106
L_Net_Ethernet_28j60_UserTCP105:
;webserver.c,411 :: 		break;
	JMP        L_Net_Ethernet_28j60_UserTCP102
;webserver.c,412 :: 		}
L_Net_Ethernet_28j60_UserTCP106:
;webserver.c,413 :: 		}
	JMP        L_Net_Ethernet_28j60_UserTCP101
L_Net_Ethernet_28j60_UserTCP102:
;webserver.c,405 :: 		while(webSoc[FILE_HTML].bufPos < webSoc[FILE_HTML].fileSize && socket == webSoc[FILE_HTML].socket) {
L__Net_Ethernet_28j60_UserTCP160:
L__Net_Ethernet_28j60_UserTCP159:
;webserver.c,415 :: 		if((Net_Ethernet_28j60_bufferEmptyTCP(webSoc[FILE_HTML].socket) == 1) && (webSoc[FILE_HTML].bufPos >= webSoc[FILE_HTML].fileSize) && (socket == webSoc[FILE_HTML].socket)){
	PUSH       R3
	PUSH       R2
	LDS        R2, _webSoc+0
	LDS        R3, _webSoc+1
	CALL       _Net_Ethernet_28j60_bufferEmptyTCP+0
	POP        R2
	POP        R3
	CPI        R16, 1
	BREQ       L__Net_Ethernet_28j60_UserTCP256
	JMP        L__Net_Ethernet_28j60_UserTCP163
L__Net_Ethernet_28j60_UserTCP256:
	LDS        R16, _webSoc+539
	LDS        R17, _webSoc+540
	LDS        R20, _webSoc+23
	LDS        R21, _webSoc+24
	LDS        R22, _webSoc+25
	LDS        R23, _webSoc+26
	LDI        R18, 0
	MOV        R19, R18
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRSH       L__Net_Ethernet_28j60_UserTCP257
	JMP        L__Net_Ethernet_28j60_UserTCP162
L__Net_Ethernet_28j60_UserTCP257:
	LDS        R16, _webSoc+0
	LDS        R17, _webSoc+1
	CP         R2, R16
	CPC        R3, R17
	BREQ       L__Net_Ethernet_28j60_UserTCP258
	JMP        L__Net_Ethernet_28j60_UserTCP161
L__Net_Ethernet_28j60_UserTCP258:
L__Net_Ethernet_28j60_UserTCP139:
;webserver.c,416 :: 		Net_Ethernet_28j60_disconnectTCP(webSoc[FILE_HTML].socket);
	PUSH       R3
	PUSH       R2
	LDS        R2, _webSoc+0
	LDS        R3, _webSoc+1
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
;webserver.c,417 :: 		resetSocket(FILE_HTML);
	CLR        R2
	CLR        R3
	CALL       webserver_resetSocket+0
	POP        R2
	POP        R3
;webserver.c,415 :: 		if((Net_Ethernet_28j60_bufferEmptyTCP(webSoc[FILE_HTML].socket) == 1) && (webSoc[FILE_HTML].bufPos >= webSoc[FILE_HTML].fileSize) && (socket == webSoc[FILE_HTML].socket)){
L__Net_Ethernet_28j60_UserTCP163:
L__Net_Ethernet_28j60_UserTCP162:
L__Net_Ethernet_28j60_UserTCP161:
;webserver.c,419 :: 		}
L_Net_Ethernet_28j60_UserTCP99:
;webserver.c,420 :: 		}
L_end_Net_Ethernet_28j60_UserTCP:
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	SUBI       R28, 29
	SBCI       R29, 255
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Net_Ethernet_28j60_UserTCP

_Net_Ethernet_28j60_UserUDP:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 13
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;webserver.c,422 :: 		unsigned int Net_Ethernet_28j60_UserUDP(UDP_28j60_Dsc *udpDsc) {
;webserver.c,424 :: 		if(udpDsc->destPort == SNTP_PORT){
	PUSH       R4
	PUSH       R5
	MOVW       R30, R2
	ADIW       R30, 12
	LD         R16, Z+
	LD         R17, Z+
	CPI        R17, 0
	BRNE       L__Net_Ethernet_28j60_UserUDP260
	CPI        R16, 123
L__Net_Ethernet_28j60_UserUDP260:
	BREQ       L__Net_Ethernet_28j60_UserUDP261
	JMP        L_Net_Ethernet_28j60_UserUDP110
L__Net_Ethernet_28j60_UserUDP261:
;webserver.c,426 :: 		unsigned long tts = 0;                      //!< Holds the time returned from the remote SNTP
	LDI        R27, 0
	STD        Y+7, R27
	STD        Y+8, R27
	STD        Y+9, R27
	STD        Y+10, R27
;webserver.c,427 :: 		int i = 0;
;webserver.c,429 :: 		tmResp.serverFlags = Net_Ethernet_28j60_getByte() ;
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_getByte+0
;webserver.c,430 :: 		tmResp.serverStratum = Net_Ethernet_28j60_getByte() ;
	CALL       _Net_Ethernet_28j60_getByte+0
;webserver.c,431 :: 		Net_Ethernet_28j60_getByte() ;              // skip poll
	CALL       _Net_Ethernet_28j60_getByte+0
;webserver.c,432 :: 		tmResp.serverPrecision = Net_Ethernet_28j60_getByte() ;
	CALL       _Net_Ethernet_28j60_getByte+0
	POP        R2
	POP        R3
;webserver.c,434 :: 		for(i = 0 ; i < 36 ; i++){
; i start address is: 18 (R18)
	LDI        R18, 0
	LDI        R19, 0
; i end address is: 18 (R18)
L_Net_Ethernet_28j60_UserUDP111:
; i start address is: 18 (R18)
	LDI        R16, 36
	LDI        R17, 0
	CP         R18, R16
	CPC        R19, R17
	BRLT       L__Net_Ethernet_28j60_UserUDP262
	JMP        L_Net_Ethernet_28j60_UserUDP112
L__Net_Ethernet_28j60_UserUDP262:
;webserver.c,435 :: 		Net_Ethernet_28j60_getByte() ;        // skip all unused fileds
	PUSH       R19
	PUSH       R18
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_getByte+0
	POP        R2
	POP        R3
	POP        R18
	POP        R19
;webserver.c,434 :: 		for(i = 0 ; i < 36 ; i++){
	MOVW       R16, R18
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R18, R16
;webserver.c,436 :: 		}
; i end address is: 18 (R18)
	JMP        L_Net_Ethernet_28j60_UserUDP111
L_Net_Ethernet_28j60_UserUDP112:
;webserver.c,439 :: 		Highest(tts) = Net_Ethernet_28j60_getByte() ;
	MOVW       R16, R28
	SUBI       R16, 249
	SBCI       R17, 255
	SUBI       R16, 253
	SBCI       R17, 255
	STD        Y+11, R16
	STD        Y+12, R17
	PUSH       R3
	PUSH       R2
	CALL       _Net_Ethernet_28j60_getByte+0
	LDD        R17, Y+11
	LDD        R18, Y+12
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;webserver.c,440 :: 		Higher(tts) = Net_Ethernet_28j60_getByte() ;
	MOVW       R16, R28
	SUBI       R16, 249
	SBCI       R17, 255
	SUBI       R16, 254
	SBCI       R17, 255
	STD        Y+11, R16
	STD        Y+12, R17
	CALL       _Net_Ethernet_28j60_getByte+0
	LDD        R17, Y+11
	LDD        R18, Y+12
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;webserver.c,441 :: 		Hi(tts) = Net_Ethernet_28j60_getByte() ;
	MOVW       R16, R28
	SUBI       R16, 249
	SBCI       R17, 255
	SUBI       R16, 255
	SBCI       R17, 255
	STD        Y+11, R16
	STD        Y+12, R17
	CALL       _Net_Ethernet_28j60_getByte+0
	LDD        R17, Y+11
	LDD        R18, Y+12
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;webserver.c,442 :: 		Lo(tts) = Net_Ethernet_28j60_getByte() ;
	MOVW       R16, R28
	SUBI       R16, 249
	SBCI       R17, 255
	STD        Y+11, R16
	STD        Y+12, R17
	CALL       _Net_Ethernet_28j60_getByte+0
	LDD        R17, Y+11
	LDD        R18, Y+12
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;webserver.c,447 :: 		logEvent(LOG_NORMAL, "SNTP Time Sync");
	LDI        R27, #lo_addr(?lstr27_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr27_webserver+0)
	MOV        R5, R27
	CLR        R2
	CLR        R3
	CALL       _logEvent+0
	POP        R2
	POP        R3
;webserver.c,448 :: 		return (udpDsc->dataLength);
	MOVW       R30, R2
	ADIW       R30, 14
	LD         R16, Z+
	LD         R17, Z+
	JMP        L_end_Net_Ethernet_28j60_UserUDP
;webserver.c,449 :: 		}
L_Net_Ethernet_28j60_UserUDP110:
;webserver.c,451 :: 		return 0;
	LDI        R16, 0
	LDI        R17, 0
;webserver.c,452 :: 		}
;webserver.c,451 :: 		return 0;
;webserver.c,452 :: 		}
L_end_Net_Ethernet_28j60_UserUDP:
	POP        R5
	POP        R4
	ADIW       R28, 12
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Net_Ethernet_28j60_UserUDP

_setIP:

;webserver.c,454 :: 		void setIP(ipAddress_t *address){
;webserver.c,455 :: 		myIpAddr[0] = address->ip1;
	MOVW       R30, R2
	LD         R16, Z
	STS        _myIpAddr+0, R16
;webserver.c,456 :: 		myIpAddr[1] = address->ip2;
	MOVW       R30, R2
	ADIW       R30, 1
	LD         R16, Z
	STS        _myIpAddr+1, R16
;webserver.c,457 :: 		myIpAddr[2] = address->ip3;
	MOVW       R30, R2
	ADIW       R30, 2
	LD         R16, Z
	STS        _myIpAddr+2, R16
;webserver.c,458 :: 		myIpAddr[3] = address->ip4;
	MOVW       R30, R2
	ADIW       R30, 3
	LD         R16, Z
	STS        _myIpAddr+3, R16
;webserver.c,459 :: 		}
L_end_setIP:
	RET
; end of _setIP

_setSubIP:

;webserver.c,461 :: 		void setSubIP(ipAddress_t *address){
;webserver.c,462 :: 		ipMask[0] = address->ip1;
	MOVW       R30, R2
	LD         R16, Z
	STS        _ipMask+0, R16
;webserver.c,463 :: 		ipMask[1] = address->ip2;
	MOVW       R30, R2
	ADIW       R30, 1
	LD         R16, Z
	STS        _ipMask+1, R16
;webserver.c,464 :: 		ipMask[2] = address->ip3;
	MOVW       R30, R2
	ADIW       R30, 2
	LD         R16, Z
	STS        _ipMask+2, R16
;webserver.c,465 :: 		ipMask[3] = address->ip4;
	MOVW       R30, R2
	ADIW       R30, 3
	LD         R16, Z
	STS        _ipMask+3, R16
;webserver.c,466 :: 		}
L_end_setSubIP:
	RET
; end of _setSubIP

_setGW:

;webserver.c,468 :: 		void setGW(ipAddress_t *address){
;webserver.c,469 :: 		gwIpAddr[0] = address->ip1;
	MOVW       R30, R2
	LD         R16, Z
	STS        _gwIpAddr+0, R16
;webserver.c,470 :: 		gwIpAddr[1] = address->ip2;
	MOVW       R30, R2
	ADIW       R30, 1
	LD         R16, Z
	STS        _gwIpAddr+1, R16
;webserver.c,471 :: 		gwIpAddr[2] = address->ip3;
	MOVW       R30, R2
	ADIW       R30, 2
	LD         R16, Z
	STS        _gwIpAddr+2, R16
;webserver.c,472 :: 		gwIpAddr[3] = address->ip4;
	MOVW       R30, R2
	ADIW       R30, 3
	LD         R16, Z
	STS        _gwIpAddr+3, R16
;webserver.c,473 :: 		}
L_end_setGW:
	RET
; end of _setGW

_setDNS:

;webserver.c,475 :: 		void setDNS(ipAddress_t *address){
;webserver.c,476 :: 		dnsIpAddr[0] = address->ip1;
	MOVW       R30, R2
	LD         R16, Z
	STS        _dnsIpAddr+0, R16
;webserver.c,477 :: 		dnsIpAddr[1] = address->ip2;
	MOVW       R30, R2
	ADIW       R30, 1
	LD         R16, Z
	STS        _dnsIpAddr+1, R16
;webserver.c,478 :: 		dnsIpAddr[2] = address->ip3;
	MOVW       R30, R2
	ADIW       R30, 2
	LD         R16, Z
	STS        _dnsIpAddr+2, R16
;webserver.c,479 :: 		dnsIpAddr[3] = address->ip4;
	MOVW       R30, R2
	ADIW       R30, 3
	LD         R16, Z
	STS        _dnsIpAddr+3, R16
;webserver.c,480 :: 		}
L_end_setDNS:
	RET
; end of _setDNS

_setPort:

;webserver.c,482 :: 		void setPort(unsigned short portNum){
;webserver.c,483 :: 		portNumber = portNum;
	STS        _portNumber+0, R2
;webserver.c,484 :: 		}
L_end_setPort:
	RET
; end of _setPort

_setDHCP:

;webserver.c,486 :: 		void setDHCP(int mode){
;webserver.c,487 :: 		dhcp_mode = mode;
	STS        _dhcp_mode+0, R2
	STS        _dhcp_mode+1, R3
;webserver.c,488 :: 		}
L_end_setDHCP:
	RET
; end of _setDHCP

_logEvent:

;webserver.c,490 :: 		void logEvent(int log, char* text){
;webserver.c,491 :: 		UART_Write_Text(text);
	PUSH       R2
	PUSH       R3
	MOVW       R2, R4
	CALL       _UART_Write_Text+0
;webserver.c,492 :: 		UART_Write('\n');
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART_Write+0
;webserver.c,532 :: 		}
L_end_logEvent:
	POP        R3
	POP        R2
	RET
; end of _logEvent

_getSvrTime:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 54
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;webserver.c,534 :: 		void getSvrTime(unsigned char *ntpSrv){
;webserver.c,538 :: 		memcpy(remoteIpAddr, Net_Ethernet_28j60_dnsResolve(ntpSrv, 4), 4);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R8
	PUSH       R9
	LDI        R27, 4
	MOV        R4, R27
	CALL       _Net_Ethernet_28j60_dnsResolve+0
	MOVW       R18, R28
	SUBI       R18, 206
	SBCI       R19, 255
	LDI        R27, 4
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	MOVW       R4, R16
	MOVW       R2, R18
	CALL       _memcpy+0
;webserver.c,540 :: 		memset(sntpPkt, 0, 48);        // clear sntp packet
	MOVW       R16, R28
	LDI        R27, 48
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	CLR        R4
	MOVW       R2, R16
	CALL       _memset+0
;webserver.c,542 :: 		sntpPkt[0] = 0b00011001;       // LI = 0 ; VN = 3 ; MODE = 1
	MOVW       R30, R28
	LDI        R27, 25
	ST         Z, R27
;webserver.c,544 :: 		sntpPkt[1] = 0x00;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 1
	LDI        R27, 0
	ST         Z, R27
;webserver.c,546 :: 		sntpPkt[2] = 0x0a;             // 1024 sec (arbitrary value)
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, 10
	ST         Z, R27
;webserver.c,548 :: 		sntpPkt[3] = 0xfa;             // 0.015625 sec (arbitrary value)
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 3
	LDI        R27, 250
	ST         Z, R27
;webserver.c,550 :: 		sntpPkt[6] = 0x44 ;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 6
	LDI        R27, 68
	ST         Z, R27
;webserver.c,552 :: 		sntpPkt[9] = 0x10 ;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 9
	LDI        R27, 16
	ST         Z, R27
;webserver.c,563 :: 		Net_Ethernet_28j60_sendUDP(remoteIpAddr, SNTP_PORT, SNTP_PORT, sntpPkt, 48);
	MOVW       R18, R28
	MOVW       R16, R28
	SUBI       R16, 206
	SBCI       R17, 255
	MOVW       R8, R18
	LDI        R27, 123
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	LDI        R27, 123
	MOV        R4, R27
	LDI        R27, 0
	MOV        R5, R27
	MOVW       R2, R16
	LDI        R27, 0
	PUSH       R27
	LDI        R27, 48
	PUSH       R27
	CALL       _Net_Ethernet_28j60_sendUDP+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 2
	OUT        SPL+0, R26
	OUT        SPL+1, R27
;webserver.c,565 :: 		}
L_end_getSvrTime:
	POP        R9
	POP        R8
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 53
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _getSvrTime

_getSvrData:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;webserver.c,567 :: 		char* getSvrData(unsigned char *request){
;webserver.c,578 :: 		i = Net_Ethernet_28j60_connectTCP(request, 80, 10000, &socket_global);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R8
	PUSH       R9
	MOVW       R16, R28
	MOVW       R8, R16
	LDI        R27, 16
	MOV        R6, R27
	LDI        R27, 39
	MOV        R7, R27
	LDI        R27, 80
	MOV        R4, R27
	LDI        R27, 0
	MOV        R5, R27
	CALL       _Net_Ethernet_28j60_connectTCP+0
;webserver.c,579 :: 		Net_Ethernet_28j60_startSendTCP(socket_global);
	LDD        R2, Y+0
	LDD        R3, Y+1
	CALL       _Net_Ethernet_28j60_startSendTCP+0
;webserver.c,580 :: 		}
L_end_getSvrData:
	POP        R9
	POP        R8
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _getSvrData

_doPacket:

;webserver.c,582 :: 		void doPacket(){
;webserver.c,583 :: 		Net_Ethernet_28j60_doPacket();
	PUSH       R2
	CALL       _Net_Ethernet_28j60_doPacket+0
;webserver.c,584 :: 		if(sdCardInsert == 1) {
	LDS        R27, _sdCardInsert+0
	SBRS       R27, BitPos(_sdCardInsert+0)
	JMP        L_doPacket114
;webserver.c,585 :: 		startFS();
	CALL       webserver_startFS+0
;webserver.c,586 :: 		}
L_doPacket114:
;webserver.c,587 :: 		if(Net_Ethernet_28j60_doDHCPLeaseTime() && dhcp_mode == DHCP_ON){
	CALL       _Net_Ethernet_28j60_doDHCPLeaseTime+0
	TST        R16
	BRNE       L__doPacket273
	JMP        L__doPacket169
L__doPacket273:
	LDS        R16, _dhcp_mode+0
	LDS        R17, _dhcp_mode+1
	CPI        R17, 0
	BRNE       L__doPacket274
	CPI        R16, 1
L__doPacket274:
	BREQ       L__doPacket275
	JMP        L__doPacket168
L__doPacket275:
L__doPacket167:
;webserver.c,588 :: 		Net_Ethernet_28j60_renewDHCP(5); // it's time to renew the IP address lease, with 5 secs for a reply
	LDI        R27, 5
	MOV        R2, R27
	CALL       _Net_Ethernet_28j60_renewDHCP+0
;webserver.c,587 :: 		if(Net_Ethernet_28j60_doDHCPLeaseTime() && dhcp_mode == DHCP_ON){
L__doPacket169:
L__doPacket168:
;webserver.c,590 :: 		}
L_end_doPacket:
	POP        R2
	RET
; end of _doPacket

_getNumFreeSockets:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 4
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;webserver.c,592 :: 		int getNumFreeSockets(){
;webserver.c,593 :: 		int i = 0, count = 0;
	PUSH       R2
	PUSH       R3
	LDI        R27, 0
	STD        Y+2, R27
	STD        Y+3, R27
;webserver.c,595 :: 		for(i=0; i< MAX_SOCKETS; i++){
	LDI        R27, 0
	STD        Y+0, R27
	STD        Y+1, R27
L_getNumFreeSockets118:
	LDD        R18, Y+0
	LDD        R19, Y+1
	LDI        R16, 5
	LDI        R17, 0
	CP         R18, R16
	CPC        R19, R17
	BRLT       L__getNumFreeSockets277
	JMP        L_getNumFreeSockets119
L__getNumFreeSockets277:
;webserver.c,596 :: 		if(webSoc[i].socket->open == 1) count++;
	LDI        R16, 29
	LDI        R17, 2
	LDD        R20, Y+0
	LDD        R21, Y+1
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z+
	LD         R17, Z+
	MOVW       R30, R16
	ADIW       R30, 34
	LD         R16, Z
	CPI        R16, 1
	BREQ       L__getNumFreeSockets278
	JMP        L_getNumFreeSockets121
L__getNumFreeSockets278:
	LDD        R16, Y+2
	LDD        R17, Y+3
	SUBI       R16, 255
	SBCI       R17, 255
	STD        Y+2, R16
	STD        Y+3, R17
L_getNumFreeSockets121:
;webserver.c,597 :: 		if(webSoc[i].mark = 0 && webSoc[i].socket->open == 0) Net_Ethernet_28j60_disconnectTCP(webSoc[i].socket);
	LDI        R16, 29
	LDI        R17, 2
	LDD        R20, Y+0
	LDD        R21, Y+1
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 254
	SBCI       R17, 255
	MOVW       R30, R16
	LDI        R27, 0
	ST         Z, R27
	MOVW       R30, R16
	LD         R16, Z
	TST        R16
	BRNE       L__getNumFreeSockets279
	JMP        L_getNumFreeSockets122
L__getNumFreeSockets279:
	LDI        R16, 29
	LDI        R17, 2
	LDD        R20, Y+0
	LDD        R21, Y+1
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z+
	LD         R17, Z+
	MOVW       R2, R16
	CALL       _Net_Ethernet_28j60_disconnectTCP+0
L_getNumFreeSockets122:
;webserver.c,595 :: 		for(i=0; i< MAX_SOCKETS; i++){
	LDD        R16, Y+0
	LDD        R17, Y+1
	SUBI       R16, 255
	SBCI       R17, 255
	STD        Y+0, R16
	STD        Y+1, R17
;webserver.c,598 :: 		}
	JMP        L_getNumFreeSockets118
L_getNumFreeSockets119:
;webserver.c,599 :: 		return count;
	LDD        R16, Y+2
	LDD        R17, Y+3
;webserver.c,600 :: 		}
;webserver.c,599 :: 		return count;
;webserver.c,600 :: 		}
L_end_getNumFreeSockets:
	POP        R3
	POP        R2
	ADIW       R28, 3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _getNumFreeSockets

webserver_startFS:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;webserver.c,602 :: 		static void startFS(){
;webserver.c,603 :: 		if(Mmc_Insert_Detect == 0){
	PUSH       R2
	PUSH       R3
	IN         R27, PORTC5_bit+0
	SBRC       R27, BitPos(PORTC5_bit+0)
	JMP        L_webserver_startFS123
;webserver.c,604 :: 		switch (FAT32_Init()){
	CALL       _FAT32_Init+0
	STD        Y+0, R16
	JMP        L_webserver_startFS124
;webserver.c,605 :: 		case 0:
L_webserver_startFS126:
;webserver.c,606 :: 		Delay_ms(50);
	LDI        R18, 3
	LDI        R17, 8
	LDI        R16, 120
L_webserver_startFS127:
	DEC        R16
	BRNE       L_webserver_startFS127
	DEC        R17
	BRNE       L_webserver_startFS127
	DEC        R18
	BRNE       L_webserver_startFS127
;webserver.c,607 :: 		status = READY;
	LDS        R27, _status+0
	SBR        R27, BitMask(_status+0)
	STS        _status+0, R27
;webserver.c,608 :: 		sdCardInsert = 0;
	LDS        R27, _sdCardInsert+0
	CBR        R27, BitMask(_sdCardInsert+0)
	STS        _sdCardInsert+0, R27
;webserver.c,609 :: 		UART_Write_Text("FS Ready\n");
	LDI        R27, #lo_addr(?lstr28_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr28_webserver+0)
	MOV        R3, R27
	CALL       _UART_Write_Text+0
;webserver.c,610 :: 		break;
	JMP        L_webserver_startFS125
;webserver.c,611 :: 		default:
L_webserver_startFS129:
;webserver.c,612 :: 		status = NOTREADY;
	LDS        R27, _status+0
	CBR        R27, BitMask(_status+0)
	STS        _status+0, R27
;webserver.c,613 :: 		break;
	JMP        L_webserver_startFS125
;webserver.c,614 :: 		}
L_webserver_startFS124:
	LDD        R16, Y+0
	LDI        R17, 0
	SBRC       R16, 7
	LDI        R17, 255
	CPI        R17, 0
	BRNE       L_webserver_startFS281
	CPI        R16, 0
L_webserver_startFS281:
	BRNE       L_webserver_startFS282
	JMP        L_webserver_startFS126
L_webserver_startFS282:
	JMP        L_webserver_startFS129
L_webserver_startFS125:
;webserver.c,615 :: 		} else {
	JMP        L_webserver_startFS130
L_webserver_startFS123:
;webserver.c,616 :: 		status = NOTREADY;
	LDS        R27, _status+0
	CBR        R27, BitMask(_status+0)
	STS        _status+0, R27
;webserver.c,617 :: 		UART_Write_Text("No card detected\n");
	LDI        R27, #lo_addr(?lstr29_webserver+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr29_webserver+0)
	MOV        R3, R27
	CALL       _UART_Write_Text+0
;webserver.c,618 :: 		}
L_webserver_startFS130:
;webserver.c,619 :: 		}
L_end_startFS:
	POP        R3
	POP        R2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of webserver_startFS

_SDCardInit:

;webserver.c,621 :: 		void SDCardInit(){
;webserver.c,622 :: 		status = NOTREADY;
	LDS        R27, _status+0
	CBR        R27, BitMask(_status+0)
	STS        _status+0, R27
;webserver.c,623 :: 		PCICR |= (1<<PCIE2);                                 // Enable external pin change interrupt
	LDS        R27, PCICR+0
	SBR        R27, 4
	STS        PCICR+0, R27
;webserver.c,624 :: 		PCMSK2 |= (1<<PCINT21);
	LDS        R16, PCMSK2+0
	ORI        R16, 32
	STS        PCMSK2+0, R16
;webserver.c,625 :: 		Mmc_Insert_Direction = 0;
	IN         R27, DDC5_bit+0
	CBR        R27, BitMask(DDC5_bit+0)
	OUT        DDC5_bit+0, R27
;webserver.c,626 :: 		startFS();
	CALL       webserver_startFS+0
;webserver.c,627 :: 		}
L_end_SDCardInit:
	RET
; end of _SDCardInit

_webserverInit:

;webserver.c,629 :: 		void webserverInit(void) {
;webserver.c,630 :: 		int i = 0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
;webserver.c,631 :: 		Net_Ethernet_28j60_stackInitTCP();                                    // Initializes the TCP stack
	CALL       _Net_Ethernet_28j60_stackInitTCP+0
;webserver.c,632 :: 		Net_Ethernet_28j60_Init(myMacAddr, myIpAddr, Net_Ethernet_28j60_FULLDUPLEX);
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, #lo_addr(_myIpAddr+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_myIpAddr+0)
	MOV        R5, R27
	LDI        R27, #lo_addr(_myMacAddr+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_myMacAddr+0)
	MOV        R3, R27
	CALL       _Net_Ethernet_28j60_Init+0
;webserver.c,634 :: 		if(dhcp_mode == DHCP_ON){
	LDS        R16, _dhcp_mode+0
	LDS        R17, _dhcp_mode+1
	CPI        R17, 0
	BRNE       L__webserverInit285
	CPI        R16, 1
L__webserverInit285:
	BREQ       L__webserverInit286
	JMP        L_webserverInit131
L__webserverInit286:
;webserver.c,635 :: 		if(Net_Ethernet_28j60_initDHCP(5) == 1){
	LDI        R27, 5
	MOV        R2, R27
	CALL       _Net_Ethernet_28j60_initDHCP+0
	CPI        R16, 1
	BREQ       L__webserverInit287
	JMP        L_webserverInit132
L__webserverInit287:
;webserver.c,636 :: 		memcpy(myIpAddr, Net_Ethernet_28j60_getIpAddress(), 4);     // fetch IP address
	CALL       _Net_Ethernet_28j60_getIpAddress+0
	LDI        R27, 4
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	MOVW       R4, R16
	LDI        R27, #lo_addr(_myIpAddr+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_myIpAddr+0)
	MOV        R3, R27
	CALL       _memcpy+0
;webserver.c,637 :: 		memcpy(gwIpAddr, Net_Ethernet_28j60_getGwIpAddress(), 4);   // fetch gateway IP address
	CALL       _Net_Ethernet_28j60_getGwIpAddress+0
	LDI        R27, 4
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	MOVW       R4, R16
	LDI        R27, #lo_addr(_gwIpAddr+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_gwIpAddr+0)
	MOV        R3, R27
	CALL       _memcpy+0
;webserver.c,638 :: 		memcpy(dnsIpAddr, Net_Ethernet_28j60_getDnsIpAddress(), 4); // fetch DNS server address
	CALL       _Net_Ethernet_28j60_getDnsIpAddress+0
	LDI        R27, 4
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	MOVW       R4, R16
	LDI        R27, #lo_addr(_dnsIpAddr+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_dnsIpAddr+0)
	MOV        R3, R27
	CALL       _memcpy+0
;webserver.c,639 :: 		memcpy(ipMask, Net_Ethernet_28j60_getIpMask(), 4);          // fetch IP subnet mask
	CALL       _Net_Ethernet_28j60_getIpMask+0
	LDI        R27, 4
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	MOVW       R4, R16
	LDI        R27, #lo_addr(_ipMask+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_ipMask+0)
	MOV        R3, R27
	CALL       _memcpy+0
;webserver.c,640 :: 		} else {
	JMP        L_webserverInit133
L_webserverInit132:
;webserver.c,641 :: 		logEvent(LOG_ERROR, "Failed to connect to DHCP server");
	LDI        R27, #lo_addr(?lstr30_webserver+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr30_webserver+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _logEvent+0
;webserver.c,642 :: 		}
L_webserverInit133:
;webserver.c,643 :: 		}
L_webserverInit131:
;webserver.c,644 :: 		Net_Ethernet_28j60_confNetwork(myIpAddr, gwIpAddr, dnsIpAddr);
	LDI        R27, #lo_addr(_dnsIpAddr+0)
	MOV        R6, R27
	LDI        R27, hi_addr(_dnsIpAddr+0)
	MOV        R7, R27
	LDI        R27, #lo_addr(_gwIpAddr+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_gwIpAddr+0)
	MOV        R5, R27
	LDI        R27, #lo_addr(_myIpAddr+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_myIpAddr+0)
	MOV        R3, R27
	CALL       _Net_Ethernet_28j60_confNetwork+0
;webserver.c,645 :: 		Delay_ms(1000);                                                       //Allow time for the ethernet chip to stabilize
	LDI        R18, 41
	LDI        R17, 150
	LDI        R16, 128
L_webserverInit134:
	DEC        R16
	BRNE       L_webserverInit134
	DEC        R17
	BRNE       L_webserverInit134
	DEC        R18
	BRNE       L_webserverInit134
;webserver.c,647 :: 		for(i = 0; i < MAX_SOCKETS; i++){
; i start address is: 20 (R20)
	LDI        R20, 0
	LDI        R21, 0
; i end address is: 20 (R20)
L_webserverInit136:
; i start address is: 20 (R20)
	LDI        R16, 5
	LDI        R17, 0
	CP         R20, R16
	CPC        R21, R17
	BRLT       L__webserverInit288
	JMP        L_webserverInit137
L__webserverInit288:
;webserver.c,648 :: 		webSoc[i].position = 0;
	PUSH       R21
	PUSH       R20
	LDI        R16, 29
	LDI        R17, 2
	CALL       _HWMul_16x16+0
	POP        R20
	POP        R21
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 3
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
;webserver.c,649 :: 		webSoc[i].mark = 0;
	PUSH       R21
	PUSH       R20
	LDI        R16, 29
	LDI        R17, 2
	CALL       _HWMul_16x16+0
	POP        R20
	POP        R21
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, 0
	ST         Z, R27
;webserver.c,650 :: 		memset(webSoc[i].fileName, 0, COMMANDSIZE);
	PUSH       R21
	PUSH       R20
	LDI        R16, 29
	LDI        R17, 2
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_webSoc+0)
	LDI        R19, hi_addr(_webSoc+0)
	ADD        R16, R18
	ADC        R17, R19
	SUBI       R16, 249
	SBCI       R17, 255
	LDI        R27, 13
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	CLR        R4
	MOVW       R2, R16
	CALL       _memset+0
	POP        R20
	POP        R21
;webserver.c,647 :: 		for(i = 0; i < MAX_SOCKETS; i++){
	MOVW       R16, R20
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R20, R16
;webserver.c,651 :: 		}
; i end address is: 20 (R20)
	JMP        L_webserverInit136
L_webserverInit137:
;webserver.c,652 :: 		}
L_end_webserverInit:
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _webserverInit

webserver____?ag:

L_end_webserver___?ag:
	RET
; end of webserver____?ag
