#line 1 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
#line 1 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
#line 1 "c:/users/richard/google drive/projects/servertestbox/__netethenc28j60.h"
#line 105 "c:/users/richard/google drive/projects/servertestbox/__netethenc28j60.h"
typedef struct
 {
 unsigned char valid;
 unsigned long tmr;
 unsigned char ip[4];
 unsigned char mac[6];
 } Net_Ethernet_28j60_arpCacheStruct;

extern Net_Ethernet_28j60_arpCacheStruct Net_Ethernet_28j60_arpCache[];

extern unsigned char Net_Ethernet_28j60_macAddr[6];
extern unsigned char Net_Ethernet_28j60_ipAddr[4];
extern unsigned char Net_Ethernet_28j60_gwIpAddr[4];
extern unsigned char Net_Ethernet_28j60_ipMask[4];
extern unsigned char Net_Ethernet_28j60_dnsIpAddr[4];
extern unsigned char Net_Ethernet_28j60_rmtIpAddr[4];

extern unsigned long Net_Ethernet_28j60_userTimerSec;



typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;
 unsigned int dataLength;
 unsigned int broadcastMark;
} UDP_28j60_Dsc;


extern UDP_28j60_Dsc udpRecord_28j60;



typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;

 unsigned int dataLength;
 unsigned int remoteMSS;
 unsigned int myWin;
 unsigned int myMSS;
 unsigned long mySeq;
 unsigned long myACK;

 char stateTimer;
 char retransmitTimer;
 unsigned int packetID;
 char open;
 char ID;
 char broadcastMark;
 char state;









 unsigned int nextSend;
 unsigned int lastACK;
 unsigned int lastSent;
 unsigned int lastWritten;
 unsigned int numToSend;
 char buffState;
 char *txBuffer;


} SOCKET_28j60_Dsc;


extern const char NUM_OF_SOCKET_28j60;
extern const unsigned int TCP_TX_SIZE_28j60;
extern const unsigned int MY_MSS_28j60;
extern const unsigned int SYN_FIN_WAIT_28j60;
extern const unsigned int RETRANSMIT_WAIT_28j60;

extern char tx_buffers_28j60[][];
extern SOCKET_28j60_Dsc socket_28j60[];
#line 200 "c:/users/richard/google drive/projects/servertestbox/__netethenc28j60.h"
extern void Net_Ethernet_28j60_Init(unsigned char *resetPort, unsigned char resetBit, unsigned char *CSport, unsigned char CSbit, unsigned char *mac, unsigned char *ip, unsigned char configuration);
extern unsigned char Net_Ethernet_28j60_doPacket();
extern void Net_Ethernet_28j60_putByte(unsigned char b);
extern void Net_Ethernet_28j60_putBytes(unsigned char *ptr, unsigned int n);
extern void Net_Ethernet_28j60_putConstBytes(const unsigned char *ptr, unsigned int n);
extern unsigned char Net_Ethernet_28j60_getByte();
extern void Net_Ethernet_28j60_getBytes(unsigned char *ptr, unsigned int addr, unsigned int n);
extern unsigned int Net_Ethernet_28j60_UserUDP(UDP_28j60_Dsc *udpDsc);
extern void Net_Ethernet_28j60_payloadInitUDP();
extern void Net_Ethernet_28j60_UserTCP(SOCKET_28j60_Dsc *socket);
extern void Net_Ethernet_28j60_confNetwork(char *ipMask, char *gwIpAddr, char *dnsIpAddr);

extern char Net_Ethernet_28j60_connectTCP(char *remoteIP, unsigned int remote_port ,unsigned int my_port, SOCKET_28j60_Dsc **used_socket);
extern char Net_Ethernet_28j60_disconnectTCP(SOCKET_28j60_Dsc *socket);
extern char Net_Ethernet_28j60_startSendTCP(SOCKET_28j60_Dsc *socket);

extern char Net_Ethernet_28j60_putByteTCP(char ch, SOCKET_28j60_Dsc *socket);
extern unsigned int Net_Ethernet_28j60_putBytesTCP(char *ptr,unsigned int n, SOCKET_28j60_Dsc *socket);
extern unsigned int Net_Ethernet_28j60_putConstBytesTCP(const far char *ptr,unsigned int n, SOCKET_28j60_Dsc *socket);
extern unsigned int Net_Ethernet_28j60_putStringTCP(char *ptr, SOCKET_28j60_Dsc *socket);
extern unsigned int Net_Ethernet_28j60_putConstStringTCP(const far char *ptr, SOCKET_28j60_Dsc *socket);
extern char Net_Ethernet_28j60_bufferEmptyTCP(SOCKET_28j60_Dsc *socket);
extern void Net_Ethernet_28j60_stackInitTCP();
#line 62 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
enum {
 LOG_NORMAL = 0,
 LOG_ERROR,
 LOG_UNKNOWN
};
#line 71 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
enum {
 FILE_HTML = 0,
 FILE_CSS,
 FILE_JS,
 FILE_PNG,
 FILE_ICO,
 FILE_JPG,
 FILE_LOG
};
#line 84 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
enum {
 DHCP_OFF = 0,
 DHCP_ON
};
#line 92 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
struct ipAddress_desc{
 unsigned char ip1;
 unsigned char ip2;
 unsigned char ip3;
 unsigned char ip4;
};

typedef struct ipAddress_desc ipAddress_t;
#line 105 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
struct webServer_desc {
 const void(*Init)(void);
 const void(*FSInit)(void);
 const void(*DoPacket)(void);
 const void(*LogEvent)(int log, char* text);
 const void(*SetIP)(ipAddress_t *address);
 const void(*SetSubIP)(ipAddress_t *address);
 const void(*SetGW)(ipAddress_t *address);
 const void(*SetDNS)(ipAddress_t *address);
 const void(*SetDHCP)(int mode);
 const void(*SetPort)(unsigned short portNum);
 const void(*GetTime)(unsigned char *ntpSvr);
 const char*(*GetData)(unsigned char *request);
 const int(*GetFreeSockets)(void);
};
#line 128 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void webserverInit(void);
#line 133 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void SDCardInit(void);
#line 138 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void doPacket(void);
#line 145 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void logEvent(int log, char* text);
#line 150 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setIP(ipAddress_t *address);
#line 155 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setSubIP(ipAddress_t *address);
#line 160 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setGW(ipAddress_t *address);
#line 165 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setDNS(ipAddress_t *address);
#line 170 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setDHCP(int mode);
#line 175 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
void setPort(unsigned short portNum);
#line 182 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
extern void getSvrTime(unsigned char *ntpSrv);
#line 196 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
extern char* getSvrData(unsigned char *request);
#line 203 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
extern int getNumFreeSockets(void);
#line 208 "c:/users/richard/google drive/projects/servertestbox/webserver.h"
extern struct webServer_desc Webserver;
#line 1 "c:/c4w/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 1 "c:/users/richard/google drive/projects/servertestbox/__lib_fat32.h"
#line 29 "c:/users/richard/google drive/projects/servertestbox/__lib_fat32.h"
typedef unsigned short uint8;
typedef signed short int8;
typedef unsigned int uint16;
typedef signed int int16;
typedef unsigned long uint32;
typedef signed long int32;
typedef unsigned long long uint64;
typedef signed long long int64;

static const uint16 SECTOR_SIZE = 512;









static const uint8
 FILE_READ = 0x01,
 FILE_WRITE = 0x02,
 FILE_APPEND = 0x04;






static const uint8
 ATTR_NONE = 0x00,
 ATTR_READ_ONLY = 0x01,
 ATTR_HIDDEN = 0x02,
 ATTR_SYSTEM = 0x04,
 ATTR_VOLUME_ID = 0x08,
 ATTR_DIRECTORY = 0x10,
 ATTR_ARCHIVE = 0x20,
 ATTR_DEVICE = 0x40,

 ATTR_RESERVED = 0x80;

static const uint8
 ATTR_LONG_NAME = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_VOLUME_ID;

static const uint8
 ATTR_FILE_MASK = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_ARCHIVE,

 ATTR_LONG_NAME_MASK = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_VOLUME_ID |
 ATTR_DIRECTORY |
 ATTR_ARCHIVE;






static const int8



 OK = 0,
 ERROR = -1,
 FOUND = 1,



 E_READ = -1,
 E_WRITE = -2,
 E_INIT_CARD = -3,
 E_BOOT_SIGN = -4,
 E_BOOT_REC = -5,
 E_FILE_SYS_INFO = -6,
 E_DEVICE_SIZE = -7,
 E_FAT_TYPE = -8,



 E_LAST_ENTRY = -10,
 E_FREE_ENTRY = -11,
 E_CLUST_NUM = -12,
 E_NO_SWAP_SPACE = -13,
 E_NO_SPACE = -14,



 E_DIR_NAME = -20,
 E_ISNT_DIR = -21,
 E_DIR_EXISTS = -22,
 E_DIR_NOTFOUND = -23,
 E_DIR_NOTEMPTY = -24,



 E_FILE_NAME = -30,
 E_ISNT_FILE = -31,
 E_FILE_EXISTS = -32,
 E_FILE_NOTFOUND = -33,
 E_FILE_NOTEMPTY = -34,
 E_MAX_FILES = -35,
 E_FILE_NOTOPENED = -36,
 E_FILE_EOF = -37,
 E_FILE_READ = -38,
 E_FILE_WRITE = -39,
 E_FILE_HANDLE = -40,
 E_FILE_READ_ONLY = -41,
 E_FILE_OPENED = -42,



 E_TIME_YEAR = -50,
 E_TIME_MONTH = -51,
 E_TIME_DAY = -52,
 E_TIME_HOUR = -53,
 E_TIME_MINUTE = -54,
 E_TIME_SECOND = -55;



typedef struct
{
 uint8 State[1];
 uint8 __1[3];
 uint8 Type[1];
 uint8 __2[3];
 uint8 Boot[4];
 uint8 Size[4];
}
FAT32_PART;



typedef struct
{
 uint8 __1[446];
 FAT32_PART Part[4];
 uint8 BootSign[2];
}
FAT32_MBR;



typedef struct
{
 uint8 JmpCode[3];
 uint8 __1[8];
 uint8 BytesPSect[2];
 uint8 SectsPClust[1];
 uint8 Reserved[2];
 uint8 FATCopies[1];
 uint8 __2[4];
 uint8 MediaDesc[1];
 uint8 __3[10];
 uint8 Sects[4];
 uint8 SectsPFAT[4];
 uint8 Flags[2];
 uint8 __4[2];
 uint8 RootClust[4];
 uint8 FSISect[2];
 uint8 BootBackup[2];
 uint8 __5[14];
 uint8 ExtSign[1];
 uint8 __6[4];
 uint8 VolName[11];
 uint8 FATName[8];
 uint8 __7[420];
 uint8 BootSign[2];
}
FAT32_BR;



typedef struct
{
 uint8 LeadSig[4];
 uint8 __1[480];
 uint8 StrucSig[4];
 uint8 FreeCount[4];
 uint8 NextFree[4];
 uint8 __2[14];
 uint8 TrailSig[2];
}
FAT32_FSI;


typedef struct
{
 uint8 Entry[4];
}
FAT32_FATENT;



typedef struct
{
 uint8 NameExt[11];
 uint8 Attrib[1];
 uint8 __1[2];
 uint8 CTime[2];
 uint8 CDate[2];
 uint8 ATime[2];
 uint8 HiClust[2];
 uint8 MTime[2];
 uint8 MDate[2];
 uint8 LoClust[2];
 uint8 Size[4];
}
FAT32_DIRENT;



typedef uint32 __CLUSTER;
typedef uint32 __SECTOR;
typedef uint32 __ENTRY;

typedef int8 __HANDLE;



typedef struct
{
 uint16 Year;
 uint8 Month;
 uint8 Day;
 uint8 Hour;
 uint8 Minute;
 uint8 Second;
}
__TIME;



typedef struct
{
 uint8 State;
 uint8 Type;
 __SECTOR Boot;
 uint32 Size;
}
__PART;



typedef struct
{
 __PART Part[1];
 uint16 BytesPSect;
 uint8 SectsPClust;
 uint16 Reserved;
 uint8 FATCopies;
 uint32 SectsPFAT;
 uint16 Flags;
 __SECTOR FAT;
 __CLUSTER Root;
 __SECTOR Data;
 __SECTOR FSI;
 uint32 ClFreeCount;
 __CLUSTER ClNextFree;
}
__INFO;


typedef struct
{
 char NameExt[13];
 uint8 Attrib;

 uint32 Size;
 __CLUSTER _1stClust;

 __CLUSTER EntryClust;
 __ENTRY Entry;
}
__DIR;


typedef struct
{
 __CLUSTER _1stClust;
 __CLUSTER CurrClust;

 __CLUSTER EntryClust;
 __ENTRY Entry;

 uint32 Cursor;
 uint32 Length;

 uint8 Mode;
 uint8 Attr;
}
__FILE;
#line 332 "c:/users/richard/google drive/projects/servertestbox/__lib_fat32.h"
typedef struct
{
 __SECTOR fSectNum;
 char fSect[SECTOR_SIZE];
}
__RAW_SECTOR;


extern const char CRLF_F32[];
extern const uint8 FAT32_MAX_FILES;
extern const uint8 f32_fsi_template[SECTOR_SIZE];
extern const uint8 f32_br_template[SECTOR_SIZE];
extern __FILE fat32_fdesc[];
extern __RAW_SECTOR f32_sector;


extern int8 FAT32_Dev_Init (void);
extern int8 FAT32_Dev_Read_Sector (__SECTOR sc, char* buf);
extern int8 FAT32_Dev_Write_Sector (__SECTOR sc, char* buf);
extern int8 FAT32_Dev_Multi_Read_Stop();
extern int8 FAT32_Dev_Multi_Read_Sector(char* buf);
extern int8 FAT32_Dev_Multi_Read_Start(__SECTOR sc);
extern int8 FAT32_Put_Char (char ch);


int8 FAT32_Init (void);
int8 FAT32_Format (char *devLabel);
int8 FAT32_ScanDisk (uint32 *totClust, uint32 *freeClust, uint32 *badClust);
int8 FAT32_GetFreeSpace(uint32 *freeClusts, uint16 *bytesPerClust);

int8 FAT32_ChangeDir (char *dname);
int8 FAT32_MakeDir (char *dname);
int8 FAT32_Dir (void);
int8 FAT32_FindFirst (__DIR *pDE);
int8 FAT32_FindNext (__DIR *pDE);
int8 FAT32_Delete (char *fn);
int8 FAT32_DeleteRec (char *fn);
int8 FAT32_Exists (char *name);
int8 FAT32_Rename (char *oldName, char *newName);
int8 FAT32_Open (char *fn, uint8 mode);
int8 FAT32_Eof (__HANDLE fHandle);
int8 FAT32_Read (__HANDLE fHandle, char* rdBuf, uint16 len);
int8 FAT32_Write (__HANDLE fHandle, char* wrBuf, uint16 len);
int8 FAT32_Seek (__HANDLE fHandle, uint32 pos);
int8 FAT32_Tell (__HANDLE fHandle, uint32 *pPos);
int8 FAT32_Close (__HANDLE fHandle);
int8 FAT32_Size (char *fname, uint32 *pSize);
int8 FAT32_GetFileHandle(char *fname, __HANDLE *handle);

int8 FAT32_SetTime (__TIME *pTM);
int8 FAT32_IncTime (uint32 Sec);

int8 FAT32_GetCTime (char *fname, __TIME *pTM);
int8 FAT32_GetMTime (char *fname, __TIME *pTM);

int8 FAT32_SetAttr (char *fname, uint8 attr);
int8 FAT32_GetAttr (char *fname, uint8* attr);

int8 FAT32_GetError (void);

int8 FAT32_MakeSwap (char *name, __SECTOR nSc, __CLUSTER *pCl);
#line 20 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
sfr sbit Net_Ethernet_28j60_Rst at PORTA0_bit;
sfr sbit Net_Ethernet_28j60_CS at PORTC2_bit;
sfr sbit Net_Ethernet_28j60_Rst_Direction at DDA0_bit;
sfr sbit Net_Ethernet_28j60_CS_Direction at DDC2_bit;

sbit Mmc_Chip_Select at PORTC4_bit;
sbit Mmc_Chip_Select_Direction at DDC4_bit;
sbit Mmc_Insert_Detect at PORTC5_bit;
sbit Mmc_Insert_Direction at DDC5_bit;

unsigned char myMacAddr[6] = {0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f};
unsigned char myIpAddr[4] = {192, 168, 1, 150};
unsigned char gwIpAddr[4] = {192, 168, 1, 1};
unsigned char ipMask[4] = {255, 255, 255, 0};
unsigned char dnsIpAddr[4] = {192, 168, 20, 1};
unsigned short portNumber = 80;
int dhcp_mode = DHCP_OFF;
#line 44 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
struct webSocket_desc{
 SOCKET_28j60_Dsc *socket;
 char mark;
 unsigned long position;
 char fileName[ 13 ];
 __HANDLE fileHandle;
 int fileType;
 unsigned long fileSize;
 char buffer[ 512 ];
 unsigned int bufPos;
};

typedef struct webSocket_desc webSocket_desc_t;

webSocket_desc_t webSoc[ 5 ];
volatile bit status;
volatile bit sdCardInsert;

struct SNTP_Response{
 long epoch;
 unsigned char serverFlags;
 unsigned char serverStratum;
 char serverPrecision;
};

struct webServer_desc Webserver = {
 &webserverInit,
 &SDCardInit,
 &doPacket,
 &logEvent,
 &setIP,
 &setSubIP,
 &setGW,
 &setDNS,
 &setDHCP,
 &setPort,
 &getSvrTime,
 &getSvrData,
 &getNumFreeSockets
};
#line 88 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
code const char httpHead[] = "HTTP/1.1 200 OK\n" ;
code const char httpDate[] = "Date: Tue, 02 Jan 2013 08:12:31 GMT\n";
code const char httpServer[] = "Server: alphaloewe 0.1.1\n";
code const char httpConnectionClose[]= "Connection: close\n";
code const char httpConnectionAlive[]= "Connection: Keep-Alive\n";
code const char httpConnectionKeep[] = "Keep-Alive: timeout=15, max=15\n";
code const char httpTransferEn[] = "Transfer-Encodeing: chunked\n";
code const char httpPragmaDir[] = "Pragma-directive: no-cache\n";
code const char httpCacheDir[] = "Cache-directive: no-cache\n";
code const char httpCacheCon[] = "Cache-control: no-store\n";
code const char httpPragma[] = "Pragma: nocache\n";
code const char httpContentType[] = "Content-Type: ";
code const char httpContentLength[] = "Content-Length: ";
code const char httpMimeTypeHTML[] = "text/html\n\n" ;
code const char httpMimeTypeCSS[] = "text/css\n\n" ;
code const char httpMimeTypeJS[] = "application/javascript\n\n";
code const char httpMimeTypeJPG[] = "image/jpg\n\n";
code const char httpMimeTypePNG[] = "image/png\n\n";
code const char httpNotSupported[] = "HTTP/1.1 501 Not Implemented\n\n";
code const char errorPage[] = "<!doctype html><html><head><meta charset=\"utf-8\"><title>Error</title></head><h1>Error</h1><body><p>The Webserver Cannot find its' media. Please insert the SD Card.</p></body><footer><a href=\"www.alphloewe.com\" title=\"Alphaloewe Home\">AlphaLoewe</a></footer></html>";
#line 118 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
static char* codeTxt2RamTxt(const char *ctxt);
#line 123 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
static void startFS(void);
#line 130 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
static void resetSocket(int socket);
#line 142 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
static int validateFile(int file_t, int index, char* name);
#line 148 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
void cardInsertISR() iv IVT_ADDR_PCINT2 ics ICS_AUTO {
 if(Button(&PINC, 5, 30, 0)) {
 sdCardInsert = 1;
 } else {
 sdCardInsert = 0;
 status =  0 ;
 }
}

static int validateFile(int file_t, int index, char* name){
 FAT32_ChangeDir("\\");
 FAT32_ChangeDir("WEB");
 switch (file_t){
 case FILE_CSS:
 FAT32_ChangeDir("STYLES");
 break;
 case FILE_JS:
 FAT32_ChangeDir("SCRIPTS");
 break;
 case FILE_PNG:
 FAT32_ChangeDir("IMAGES");
 break;
 case FILE_JPG:
 FAT32_ChangeDir("IMAGES");
 break;
 }
 if(FAT32_Exists(name) == 1){
 webSoc[index].filetype = file_t;
 webSoc[index].mark = 1;
 webSoc[index].position = 0;
 strcpy(&webSoc[index].fileName, name);
 FAT32_Size(webSoc[index].fileName, &webSoc[index].fileSize);
 webSoc[index].fileHandle = FAT32_Open(&webSoc[index].fileName, FILE_READ);
 if(webSoc[index].fileHandle == -1) logEvent(LOG_ERROR, "Filehandle Failed");

 memset(&webSoc[index].buffer, 0,  512 );
 if(FAT32_Read(webSoc[index].fileHandle, &webSoc[index].buffer,  512 )==0){
 webSoc[index].bufPos = 0;
 } else {
 logEvent(LOG_ERROR, "Could not read from file");
 FAT32_ChangeDir("\\");
 return 0;
 }
 FAT32_ChangeDir("\\");
 return 1;
 } else {
 FAT32_ChangeDir("\\");
 return 0;
 }
}

static void resetSocket(int socNum){
 webSoc[socNum].position = 0;
 webSoc[socNum].mark = 0;
 webSoc[socNum].bufPos = 0;
 if(Net_Ethernet_28j60_disconnectTCP(webSoc[socNum].socket) == 0){
 logEvent(LOG_ERROR, "Failed to Close Socket\n");
 }
}

static char *codeTxt2RamTxt(const char *ctxt){
 static char txt[20];
 int i = 0;

 for(i =0; txt[i] = ctxt[i]; i++);
 return &txt;
}

void Net_Ethernet_28j60_UserTCP(SOCKET_28j60_Dsc *socket) {
 if(status ==  1 ){
 int i = 0;
 if(socket->destPort != portNumber){
 return;
 } else {
 char tmpChr = 0;
 char request[ 100 ];
 char * const pRequest = &request;
 memset(pRequest, 0,  100 );

 for(i=0; i <  100 -1; i++){
 tmpChr = Net_Ethernet_28j60_getByte();
 if(tmpChr == '\n') break;
 else *(pRequest+i) = tmpChr;
 }

 if(memcmp(pRequest, "GET ", 3) == 0){
 char commands[ 7 ][ 13 ];
 char (*pCommands)[ 13 ] = &commands;
 char strC[ 13 ];
 char * const pStrC = &strC;
 int n = 0;

 strcpy(pStrC, strtok(pRequest,  " /" ));
 for(n=0; (pStrC[0] != '\0') && (n <  7 ); n++){
 strcpy(pCommands[n], pStrC);
 strcpy(pStrC, strtok(0,  " /" ));
 }

 if((strcmp(pCommands[0], "GET") == 0) && socket->state != 3){
 return;
 } else if (strcmp(pCommands[0], "GET") == 0){
 char fileStr[ 13 ];
 char * const pFileStr = &fileStr;

 memset(pFileStr, 0,  13 );
 for(i=0; i<n; i++){
 if(strcmp(pCommands[i],"HTTP") == 0){
 if(i == 1) {
 pFileStr = "index.htm";
 } else {
 strcpy(pFileStr, pCommands[i-1]);
 break;
 }
 }
 }
 for(i = 0; i <  5 ; i++){
 if(webSoc[i].mark == 0 && webSoc[i].socket->open == 1){

 char *fEnd;
 char *res;
 char txt[7];

 fEnd = strchr(pFileStr, '.');

 if(strncmp(fEnd, ".htm", 3) == 0){
 if(validateFile(FILE_HTML, i ,pFileStr)){
 webSoc[i].socket = socket;
 } else {
 Net_Ethernet_28j60_disconnectTCP(socket);
 return;
 }
 } else if(strncmp(fEnd, ".css", 3) == 0){
 if(validateFile(FILE_CSS, i ,pFileStr)){
 webSoc[i].socket = socket;
 } else {
 Net_Ethernet_28j60_disconnectTCP(socket);
 return;
 }
 } else if(strncmp(fEnd, ".js", 3) == 0){
 if(validateFile(FILE_JS, i ,pFileStr)){
 webSoc[i].socket = socket;
 } else {
 Net_Ethernet_28j60_disconnectTCP(socket);
 return;
 }
 } else if(strncmp(fEnd, ".jpg", 3) == 0){
 if(validateFile(FILE_JPG, i ,pFileStr)){
 webSoc[i].socket = socket;
 } else {
 Net_Ethernet_28j60_disconnectTCP(socket);
 return;
 }
 } else if(strncmp(fEnd, ".png", 3) == 0){
 if(validateFile(FILE_PNG, i ,pFileStr)){
 webSoc[i].socket = socket;
 } else {
 Net_Ethernet_28j60_disconnectTCP(socket);
 return;
 }
 } else if(strncmp(fEnd, ".ico", 3) == 0){
 if(validateFile(FILE_ICO, i ,pFileStr)){
 webSoc[i].socket = socket;
 } else {
 Net_Ethernet_28j60_disconnectTCP(socket);
 return;
 }
 } else {
 return;
 }

 Net_Ethernet_28j60_putConstStringTCP(httpHead, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpServer, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpDate, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpConnectionClose, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpContentLength, webSoc[i].socket);
 LongToStr(webSoc[i].fileSize, txt);
 res = Ltrim(txt);
 Net_Ethernet_28j60_putStringTCP(res, webSoc[i].socket);
 Net_Ethernet_28j60_putByteTCP('\n', webSoc[i].socket);
 switch(webSoc[i].fileType){
 case FILE_HTML:
 Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeHTML, webSoc[i].socket);
 break;
 case FILE_CSS:
 Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeCSS, webSoc[i].socket);
 break;
 case FILE_JS:
 Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeJS, webSoc[i].socket);
 break;
 case FILE_PNG:
 Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpMimeTypePNG, webSoc[i].socket);
 break;
 case FILE_JPG:
 Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeJPG, webSoc[i].socket);
 break;
 case FILE_ICO:
 Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[i].socket);
 Net_Ethernet_28j60_putConstStringTCP(httpMimeTypePNG, webSoc[i].socket);
 break;
 }
 break;
 }
 }
 }
 }
 }


 for(i = 0; i <  5 ; i++){
 if((webSoc[i].mark == 1) && (webSoc[i].socket == socket)){
 while(webSoc[i].position < webSoc[i].fileSize){
 if((webSoc[i].bufPos ==  512 ) && (FAT32_Eof(webSoc[i].fileHandle) != 1)) {
 FAT32_Read(webSoc[i].fileHandle, &webSoc[i].buffer,  512 );
 webSoc[i].bufPos = 0;
 }
 if(FAT32_Eof(webSoc[i].fileHandle) == 1) {
 FAT32_Close(webSoc[i].fileHandle);
 }
 switch(Net_Ethernet_28j60_putByteTCP(webSoc[i].buffer[webSoc[i].bufPos], webSoc[i].socket)){
 case 1:
 webSoc[i].bufPos++; webSoc[i].position++;
 break;
 case 0:
 return;
 break;
 }
 }
 if((Net_Ethernet_28j60_bufferEmptyTCP(webSoc[i].socket) == 1) && webSoc[i].position >= webSoc[i].fileSize){
 resetSocket(i);
 }
 }
 }

 } else {

 char *p;
 if(webSoc[FILE_HTML].position == 0){
 webSoc[FILE_HTML].mark = 1;
 webSoc[FILE_HTML].socket = socket;
 webSoc[FILE_HTML].bufPos = 0;
 webSoc[FILE_HTML].fileSize = 264;
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpHead, webSoc[FILE_HTML].socket);
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpServer, webSoc[FILE_HTML].socket);
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpDate, webSoc[FILE_HTML].socket);
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpConnectionClose, webSoc[FILE_HTML].socket);
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpContentLength, webSoc[FILE_HTML].socket);
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putStringTCP("264", webSoc[FILE_HTML].socket);
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putByteTCP('\n', webSoc[FILE_HTML].socket);
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpContentType, webSoc[FILE_HTML].socket);
 webSoc[FILE_HTML].position += Net_Ethernet_28j60_putConstStringTCP(httpMimeTypeHTML, webSoc[FILE_HTML].socket);
 }

 while(webSoc[FILE_HTML].bufPos < webSoc[FILE_HTML].fileSize && socket == webSoc[FILE_HTML].socket) {
 *p = errorPage[webSoc[FILE_HTML].bufPos];
 if(Net_Ethernet_28j60_putByteTCP(*p, webSoc[FILE_HTML].socket) == 1){
 webSoc[FILE_HTML].position++;
 webSoc[FILE_HTML].bufPos++;
 } else {
 break;
 }
 }

 if((Net_Ethernet_28j60_bufferEmptyTCP(webSoc[FILE_HTML].socket) == 1) && (webSoc[FILE_HTML].bufPos >= webSoc[FILE_HTML].fileSize) && (socket == webSoc[FILE_HTML].socket)){
 Net_Ethernet_28j60_disconnectTCP(webSoc[FILE_HTML].socket);
 resetSocket(FILE_HTML);
 }
 }
}

unsigned int Net_Ethernet_28j60_UserUDP(UDP_28j60_Dsc *udpDsc) {

 if(udpDsc->destPort ==  123 ){
 struct SNTP_Response tmResp;
 unsigned long tts = 0;
 int i = 0;

 tmResp.serverFlags = Net_Ethernet_28j60_getByte() ;
 tmResp.serverStratum = Net_Ethernet_28j60_getByte() ;
 Net_Ethernet_28j60_getByte() ;
 tmResp.serverPrecision = Net_Ethernet_28j60_getByte() ;

 for(i = 0 ; i < 36 ; i++){
 Net_Ethernet_28j60_getByte() ;
 }


  ((char *)&tts)[3]  = Net_Ethernet_28j60_getByte() ;
  ((char *)&tts)[2]  = Net_Ethernet_28j60_getByte() ;
  ((char *)&tts)[1]  = Net_Ethernet_28j60_getByte() ;
  ((char *)&tts)[0]  = Net_Ethernet_28j60_getByte() ;


 tmResp.epoch = tts - 2208988800;

 logEvent(LOG_NORMAL, "SNTP Time Sync");
 return (udpDsc->dataLength);
 }

 return 0;
}

void setIP(ipAddress_t *address){
 myIpAddr[0] = address->ip1;
 myIpAddr[1] = address->ip2;
 myIpAddr[2] = address->ip3;
 myIpAddr[3] = address->ip4;
}

void setSubIP(ipAddress_t *address){
 ipMask[0] = address->ip1;
 ipMask[1] = address->ip2;
 ipMask[2] = address->ip3;
 ipMask[3] = address->ip4;
}

void setGW(ipAddress_t *address){
 gwIpAddr[0] = address->ip1;
 gwIpAddr[1] = address->ip2;
 gwIpAddr[2] = address->ip3;
 gwIpAddr[3] = address->ip4;
}

void setDNS(ipAddress_t *address){
 dnsIpAddr[0] = address->ip1;
 dnsIpAddr[1] = address->ip2;
 dnsIpAddr[2] = address->ip3;
 dnsIpAddr[3] = address->ip4;
}

void setPort(unsigned short portNum){
 portNumber = portNum;
}

void setDHCP(int mode){
 dhcp_mode = mode;
}

void logEvent(int log, char* text){
 UART_Write_Text(text);
 UART_Write('\n');
#line 532 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
}

void getSvrTime(unsigned char *ntpSrv){
 unsigned char sntpPkt[50];
 unsigned char remoteIpAddr[4];

 memcpy(remoteIpAddr, Net_Ethernet_28j60_dnsResolve(ntpSrv, 4), 4);

 memset(sntpPkt, 0, 48);

 sntpPkt[0] = 0b00011001;

 sntpPkt[1] = 0x00;

 sntpPkt[2] = 0x0a;

 sntpPkt[3] = 0xfa;

 sntpPkt[6] = 0x44 ;

 sntpPkt[9] = 0x10 ;










 Net_Ethernet_28j60_sendUDP(remoteIpAddr,  123 ,  123 , sntpPkt, 48);

}

char* getSvrData(unsigned char *request){
#line 575 "C:/Users/Richard/Google Drive/Projects/ServerTestBox/webserver.c"
 SOCKET_28j60_Dsc *socket_global;
 int i;

 i = Net_Ethernet_28j60_connectTCP(request, 80, 10000, &socket_global);
 Net_Ethernet_28j60_startSendTCP(socket_global);
}

void doPacket(){
 Net_Ethernet_28j60_doPacket();
 if(sdCardInsert == 1) {
 startFS();
 }
 if(Net_Ethernet_28j60_doDHCPLeaseTime() && dhcp_mode == DHCP_ON){
 Net_Ethernet_28j60_renewDHCP(5);
 }
}

int getNumFreeSockets(){
 int i = 0, count = 0;

 for(i=0; i<  5 ; i++){
 if(webSoc[i].socket->open == 1) count++;
 if(webSoc[i].mark = 0 && webSoc[i].socket->open == 0) Net_Ethernet_28j60_disconnectTCP(webSoc[i].socket);
 }
 return count;
}

static void startFS(){
 if(Mmc_Insert_Detect == 0){
 switch (FAT32_Init()){
 case 0:
 Delay_ms(50);
 status =  1 ;
 sdCardInsert = 0;
 UART_Write_Text("FS Ready\n");
 break;
 default:
 status =  0 ;
 break;
 }
 } else {
 status =  0 ;
 UART_Write_Text("No card detected\n");
 }
}

void SDCardInit(){
 status =  0 ;
 PCICR |= (1<<PCIE2);
 PCMSK2 |= (1<<PCINT21);
 Mmc_Insert_Direction = 0;
 startFS();
}

void webserverInit(void) {
 int i = 0;
 Net_Ethernet_28j60_stackInitTCP();
 Net_Ethernet_28j60_Init(myMacAddr, myIpAddr,  0b1 );

 if(dhcp_mode == DHCP_ON){
 if(Net_Ethernet_28j60_initDHCP(5) == 1){
 memcpy(myIpAddr, Net_Ethernet_28j60_getIpAddress(), 4);
 memcpy(gwIpAddr, Net_Ethernet_28j60_getGwIpAddress(), 4);
 memcpy(dnsIpAddr, Net_Ethernet_28j60_getDnsIpAddress(), 4);
 memcpy(ipMask, Net_Ethernet_28j60_getIpMask(), 4);
 } else {
 logEvent(LOG_ERROR, "Failed to connect to DHCP server");
 }
 }
 Net_Ethernet_28j60_confNetwork(myIpAddr, gwIpAddr, dnsIpAddr);
 Delay_ms(1000);

 for(i = 0; i <  5 ; i++){
 webSoc[i].position = 0;
 webSoc[i].mark = 0;
 memset(webSoc[i].fileName, 0,  13 );
 }
}
